cstmmenu = {}
cstmmenu.PanelB = nil

-- These convars are used to communicate between with the client when the player presses "apply changes"

CreateClientConVar("cstm_accuracymod_aim_cl", "1", true, true)
CreateClientConVar("cstm_accuracymod_hip_cl", "1", true, true)
CreateClientConVar("cstm_recoilmod_cl", "1", true, true)
CreateClientConVar("cstm_damagemod_cl", "1", true, true)

CreateClientConVar("cstm_att_eotech_cl", "0", true, true)
CreateClientConVar("cstm_att_aimpoint_cl", "0", true, true)
CreateClientConVar("cstm_att_acog_cl", "0", true, true)
CreateClientConVar("cstm_att_reflex_cl", "0", true, true)
CreateClientConVar("cstm_att_vertgrip_cl", "0", true, true)
CreateClientConVar("cstm_att_m203_cl", "0", true, true)
CreateClientConVar("cstm_att_bipod_cl", "0", true, true)
CreateClientConVar("cstm_att_lasersight_cl", "0", true, true)
CreateClientConVar("cstm_att_cmag_cl", "0", true, true)

function cstmmenu.PanelA(panel)
	panel:ClearControls()
	
	panel:AddControl("Label", {Text = "Crosshair parts control"})
	panel:AddControl("CheckBox", {Label = "CROSSHAIR: Dynamic crosshair scaling", Command = "cstm_dynamiccrosshair"})
	panel:AddControl("CheckBox", {Label = "CROSSHAIR: Left cross", Command = "cstm_leftcross"})
	panel:AddControl("CheckBox", {Label = "CROSSHAIR: Right cross", Command = "cstm_rightcross"})
	panel:AddControl("CheckBox", {Label = "CROSSHAIR: Lower cross", Command = "cstm_lowercross"})
	panel:AddControl("CheckBox", {Label = "CROSSHAIR: Upper cross", Command = "cstm_uppercross"})
	panel:AddControl("Label", {Text = "Outline crosshair parts colour"})
	panel:AddControl("Color", {Label = "Outline crosshair color", Red = "cstm_out_r", Green = "cstm_out_g", Blue = "cstm_out_b", Alpha = "cstm_out_a", ShowAlpha = false, ShowHSV = true, ShowRGB = true, NumberMultiplier = "1"})
	panel:AddControl("Label", {Text = "Inline crosshair parts colour"})
	panel:AddControl("Color", {Label = "Inline crosshair color", Red = "cstm_in_r", Green = "cstm_in_g", Blue = "cstm_in_b", Alpha = "cstm_in_a", ShowAlpha = true, ShowHSV = true, ShowRGB = true, NumberMultiplier = "1"})
	panel:AddControl("Slider", {Label = "Cross length", Command = "cstm_crosslength", Type = "Integer", Min = 6, Max = 40})
	panel:AddControl("Label", {Text = "Miscellaneous"})
	panel:AddControl("CheckBox", {Label = "EFFECT: Use additional muzzleflash effects?", Command = "cstm_ef_extramuzzle"})
	panel:AddControl("CheckBox", {Label = "EFFECT: Use gunfire heat effect?", Command = "cstm_ef_heat"})
	panel:AddControl("CheckBox", {Label = "EFFECT: Use gunfire smoke effect?", Command = "cstm_ef_smoke"})
	panel:AddControl("CheckBox", {Label = "EFFECT: Use gunfire sparks effect?", Command = "cstm_ef_sparks"})
	panel:AddControl("CheckBox", {Label = "EFFECT: Use blur effect? (turn Motion Blur on first!)", Command = "cstm_ef_blur"})
	panel:AddControl("CheckBox", {Label = "VIEWBOB: upon reload?", Command = "cstm_viewbob_reload"})
	panel:AddControl("CheckBox", {Label = "VIEWBOB: upon draw?", Command = "cstm_viewbob_draw"})
	panel:AddControl("CheckBox", {Label = "VIEWBOB: upon silencer attach/detach?", Command = "cstm_viewbob_silencer"})
	panel:AddControl("CheckBox", {Label = "MISC: Use old ACOG Scope behavior?", Command = "cstm_oldacog"})
	panel:AddControl("CheckBox", {Label = "MISC: Use different weapon origins?", Command = "cstm_different_origins"})
	panel:AddControl("CheckBox", {Label = "MISC: Use hold-to-aim?", Command = "cstm_hold_to_aim"})
	
	local slider = vgui.Create("DNumSlider", panel)
	slider:SetDecimals(3)
	slider:SetMin(0.005)
	slider:SetMax(0.02)
	slider:SetConVar("cstm_aim_sensitivity")
	slider:SetValue(GetConVarNumber("cstm_aim_sensitivity"))
	slider:SetText("Aim sensitivity (higher = more sensitivity)")
	
	panel:AddItem(slider)
	//panel:AddControl("Slider", {Label = "Aim sensitivity (higher = more sensitivity)", Command = "cstm_aim_sensitivity", Type = "Float", Min = 0.005, Max = 0.009})
end

function cstmmenu.AdminPanel(panel)
	if not LocalPlayer():IsAdmin() then
		panel:AddControl("Label", {Text = "Not an admin - don't look here."})
		return
	end
	
	panel:ClearControls()
	
	local slider = vgui.Create("DNumSlider", panel)
	slider:SetDecimals(2)
	slider:SetMin(0.2)
	slider:SetMax(2)
	slider:SetConVar("cstm_accuracymod_aim_cl")
	slider:SetValue(GetConVarNumber("cstm_accuracymod_aim_cl"))
	slider:SetText("ACCURACY: Aim (higher = less spread)")
	
	panel:AddItem(slider)
	
	local slider = vgui.Create("DNumSlider", panel)
	slider:SetDecimals(2)
	slider:SetMin(0.2)
	slider:SetMax(2)
	slider:SetConVar("cstm_accuracymod_hip_cl")
	slider:SetValue(GetConVarNumber("cstm_accuracymod_hip_cl"))
	slider:SetText("ACCURACY: Hip (higher = less spread)")
	
	panel:AddItem(slider)
	
	local slider = vgui.Create("DNumSlider", panel)
	slider:SetDecimals(2)
	slider:SetMin(0.2)
	slider:SetMax(2)
	slider:SetConVar("cstm_recoilmod_cl")
	slider:SetValue(GetConVarNumber("cstm_recoilmod_cl"))
	slider:SetText("Recoil modifier (higher = more recoil)")
	
	panel:AddItem(slider)
	
	local slider = vgui.Create("DNumSlider", panel)
	slider:SetDecimals(2)
	slider:SetMin(0.2)
	slider:SetMax(2)
	slider:SetConVar("cstm_damagemod_cl")
	slider:SetValue(GetConVarNumber("cstm_damagemod_cl"))
	slider:SetText("Damage modifier (higher = more damage)")
	
	panel:AddItem(slider)
	
	panel:AddControl("CheckBox", {Label = "ON SPAWN: Give EoTech?", Description = "", Command = "cstm_att_eotech_cl"})
	panel:AddControl("CheckBox", {Label = "ON SPAWN: Give Aimpoint?", Description = "", Command = "cstm_att_aimpoint_cl"})
	panel:AddControl("CheckBox", {Label = "ON SPAWN: Give ACOG 4x?", Description = "", Command = "cstm_att_acog_cl"})
	panel:AddControl("CheckBox", {Label = "ON SPAWN: Give Docter reflex sight?", Description = "", Command = "cstm_att_reflex_cl"})
	panel:AddControl("CheckBox", {Label = "ON SPAWN: Give Foregrip?", Description = "", Command = "cstm_att_vertgrip_cl"})
	panel:AddControl("CheckBox", {Label = "ON SPAWN: Give M203?", Description = "", Command = "cstm_att_m203_cl"})
	panel:AddControl("CheckBox", {Label = "ON SPAWN: Give Bipod?", Description = "", Command = "cstm_att_bipod_cl"})
	panel:AddControl("CheckBox", {Label = "ON SPAWN: Give a Laser sight?", Description = "", Command = "cstm_att_lasersight_cl"})
	panel:AddControl("CheckBox", {Label = "ON SPAWN: Give a Beta C-Mag?", Description = "", Command = "cstm_att_cmag_cl"})
	
	panel:AddControl("Button", {Label = "Apply Changes", Command = "cstm_applychanges"})
	panel:AddControl("Button", {Label = "Reset Settings", Command = "cstm_resetsettings"})
end

function cstmmenu.OpenSpawnMenu()
	if(cstmmenu.PanelB) then
		cstmmenu.PanelA(cstmmenu.PanelB)
	end
end

hook.Add("SpawnMenuOpen", "cstmmenu.OpenSpawnMenu", cstmmenu.OpenSpawnMenu)

local function CSTM_PopulateAdminMenu()
	spawnmenu.AddToolMenuOption("Utilities", "Customizable Weaponry", "Customizable Weaponry client", "Client", "", "", cstmmenu.PanelA)
	spawnmenu.AddToolMenuOption("Utilities", "Customizable Weaponry", "Customizable Weaponry admin", "Admin", "", "", cstmmenu.AdminPanel)
end
hook.Add("PopulateToolMenu", "CSTM_PopulateAdminMenu", CSTM_PopulateAdminMenu)

local smtext = draw.SimpleText

function draw.ShadowedText(text, font, x, y, color, shadowcolor, shadowdist, al, ar, dynamic)
	if dynamic then
		HP = LocalPlayer():Health() / 100
		color = Color(200, 255 * HP, 150 * HP, 255)
	end
	
	smtext(text, font, x + shadowdist, y + shadowdist, shadowcolor, (al or TEXT_ALIGN_LEFT), (ar or TEXT_ALIGN_CENTER))
	smtext(text, font, x, y, color, (al or TEXT_ALIGN_LEFT), (ar or TEXT_ALIGN_CENTER))
end

local stext, rbox, rboxex, clr, rect, orect, vcret, tid, tex, trect = draw.ShadowedText, draw.RoundedBox, draw.RoundedBoxEx, surface.SetDrawColor, surface.DrawRect, surface.DrawOutlinedRect, vgui.Create, surface.GetTextureID, surface.SetTexture, surface.DrawTexturedRect
local ply, wep, w, h, f, a, att, vm

AttToMdl = {
	["vertgrip"] = {mdl = "models/wystan/attachments/foregrip1.mdl", t = tid("VGUI/entities/upgr_vertgrip"), n = "Foregrip"},
	["laser"] = {mdl = "models/props_c17/FurnitureBoiler001a.mdl", t = tid("VGUI/entities/upgr_lasersight"), n = "Laser sight"},
	["eotech"] = {mdl = "models/wystan/attachments/eotech557sight.mdl", t = tid("VGUI/entities/upgr_eotech557"), n = "EoTech 557"},
	["aimpoint"] = {mdl = "models/wystan/attachments/aimpoint.mdl", t = tid("VGUI/entities/upgr_aimpoint"), n = "Aimpoint"},
	["acog"] = {mdl = "models/wystan/attachments/acog.mdl", t = tid("VGUI/entities/upgr_acog"), n = "ACOG 4x"},
	["grenadelauncher"] = {mdl = "models/wystan/attachments/m203.mdl", t = tid("VGUI/entities/upgr_m203"), n = "M203"},
	["cmag"] = {mdl = "models/wystan/cmag.mdl", t = tid("VGUI/entities/upgr_cmag"), n = "Beta C-Magazine"},
	["reflex"] = {mdl = "models/wystan/attachments/doctorrds.mdl", t = tid("VGUI/entities/upgr_reflexsight"), n = "Docter red-dot sight"},
	["bipod"] = {mdl = "models/wystan/attachments/bipod.mdl", t = tid("VGUI/entities/upgr_bipod"), n = "Bipod"}}

local P = {}

function P:Init()
	self.Alpha = 0
	self.White = Color(255, 255, 255, 0)
	self.Black = Color(0, 0, 0, 0)
	self.Grey = Color(50, 50, 50, 0)
	self.Blue = Color(84, 141, 255, 0)
end

function P:Paint()
	ply = LocalPlayer()
	wep = ply:GetActiveWeapon()
	
	if not wep.IsCustomWeapon then
		self:Remove()
		return
	end
	
	if not self.DontRepos then
		vm = ply:GetViewModel()
		
		if ValidEntity(vm) then
			att = vm:GetAttachment("1").Pos:ToScreen()
			self:SetPos(att.x + 200, att.y + self.Off - 50)
		end
	end
	
	w, h = self:GetSize()
	rbox(6, 0, 0, w, h, self.Grey)
	rboxex(6, 2, 2, w - 4, 15, self.Blue, true, true, false, false)
	stext("[" .. self.Key .. "]", "UiBold", 15, 9, self.White, self.Black, 1, TEXT_ALIGN_CENTER, TEXT_ALIGN_CENTER)
	f = false
	
	if wep.Attachments[self.Key] then
		for k, v in pairs(wep.Attachments[self.Key]) do
			if wep.VElements[v] and wep.VElements[v].color.a == 255 then
				stext(AttToMdl[v].n, "UiBold", 30, 9, self.White, self.Black, 1, TEXT_ALIGN_LEFT, TEXT_ALIGN_CENTER)
				f = true
			end
		end
	end
	
	if not f then
		stext("None", "UiBold", 30, 9, self.White, self.Black, 1, TEXT_ALIGN_LEFT, TEXT_ALIGN_CENTER)
	end
	
	self.Alpha = Lerp(FrameTime() * 20, self.Alpha, 255)
	self.White.a = self.Alpha / 1.275
	self.Black.a = self.Alpha
	self.Grey.a = self.Alpha / 1.7
	self.Blue.a = self.Alpha
end

vgui.Register("AttachmentSelectionPanel", P, "DPanel")

P = {}

function P:Paint()
	if not wep.IsCustomWeapon then
		self:Remove()
		return
	end
	
	f = false
	ply = LocalPlayer()
	wep = ply:GetActiveWeapon()
	a = self:GetParent().Alpha
	
	if table.HasValue(AttOnMe, self.Att) then
		if wep.VElements[self.Att] and wep.VElements[self.Att].color.a == 255 then
			clr(163, 255, 84, a)
		else
			clr(84, 141, 255, a)
		end
		
		f = true
	else
		clr(255, 95, 10, a)
	end
	
	rect(0, 0, 50, 50)
	
	if not f then
		clr(150, 150, 150, a)
	else
		clr(255, 255, 255, a)
	end
	
	tex(self.Texture)
	trect(1, 1, 48, 48)
end

vgui.Register("AttachmentIcon", P, "DPanel")