local ra = resource.AddFile

ra("materials/gcellmats/scope_rifle2.vmt")
ra("models/wystan/attachments/2cog.mdl")
ra("models/wystan/attachments/akrailmount.mdl")
ra("models/wystan/attachments/aimpoint.mdl")
ra("models/wystan/attachments/2octorrds.mdl")
ra("models/wystan/attachments/2otech557sight.mdl")
ra("models/wystan/attachments/m203.mdl")
ra("models/wystan/attachments/bipod.mdl")
ra("models/wystan/cmag.mdl")
ra("models/wystan/attachments/foregrip1.mdl")
ra("materials/models/wystan/attachments/bipod/Harris_Bipod.vmt")
ra("materials/models/wystan/attachments/aimpoint/aim1.vmt")
ra("materials/models/wystan/attachments/aimpoint/aim2.vmt")
ra("materials/models/wystan/attachments/doctor/frame1.vmt")
ra("materials/models/wystan/attachments/eotech/557.vmt")
ra("materials/models/wystan/attachments/acog/acog.vmt")
ra("materials/models/wystan/attachments/acog/acog.vtf")
ra("materials/models/wystan/attachments/acog/lense.vmt")
ra("materials/models/wystan/attachments/acog/lense.vtf")
ra("materials/models/wystan/attachments/akrail/newscope.vmt")
ra("materials/models/wystan/attachments/m203/m203.vmt")
ra("materials/models/wystan/cmag/cmag.vmt")
ra("materials/models/wystan/cmag/bbulet.vmt")
ra("materials/models/wystan/attachments/vert.vmt")
ra("materials/models/bunneh/silencer.vmt")
ra("materials/models/bunneh/silencernormal.vtf")
ra("materials/sprites/frostbreath.vmt")
ra("materials/sprites/eotech_reddot.vmt")
ra("materials/sprites/aim_reticule.vmt")
ra("materials/sprites/acog_tri.vmt")
ra("materials/sprites/crosshair_gl.vmt")
ra("materials/effects/redlaser1.vmt")
ra("materials/VGUI/bullet.vmt")
ra("sound/weapons/cstm/attach_attachment.mp3")
ra("sound/weapons/cstm/attach.wav")
ra("sound/weapons/cstm/detach.wav")

for i = 1, 4 do
	ra("sound/weapons/cstm/holster" .. i .. ".wav")
end

ra("settings/render_targets/acog_glass_rt.txt")
ra("particles/cstm_muzzleflashes.pcf")
ra("materials/vgui/bipod_active.vmt")
ra("materials/vgui/entities/upgr_acog.vmt")
ra("materials/vgui/entities/upgr_aimpoint.vmt")
ra("materials/vgui/entities/upgr_eotech557.vmt")
ra("materials/vgui/entities/upgr_bipod.vmt")
ra("materials/vgui/entities/upgr_cmag.vmt")
ra("materials/vgui/entities/upgr_lasersight.vmt")
ra("materials/vgui/entities/upgr_m203.vmt")
ra("materials/vgui/entities/upgr_reflexsight.vmt")
ra("materials/vgui/entities/upgr_vertgrip.vmt")
AddCSLuaFile("autorun/client/medkitregenprogressbar.lua")
AddCSLuaFile("autorun/client/cstm_menu.lua")
AddCSLuaFile("autorun/particleprecache.lua")
include("autorun/particleprecache.lua")
include("autorun/physbul.lua")
CreateConVar("cstm_accuracymod_aim", "1", {FCVAR_REPLICATED, FCVAR_ARCHIVE, FCVAR_NOTIFY})
CreateConVar("cstm_accuracymod_hip", "1", {FCVAR_REPLICATED, FCVAR_ARCHIVE, FCVAR_NOTIFY})
CreateConVar("cstm_recoilmod", "1", {FCVAR_REPLICATED, FCVAR_ARCHIVE, FCVAR_NOTIFY})
CreateConVar("cstm_damagemod", "1", {FCVAR_REPLICATED, FCVAR_ARCHIVE, FCVAR_NOTIFY})
CreateConVar("cstm_att_eotech", "0", {FCVAR_REPLICATED, FCVAR_ARCHIVE, FCVAR_NOTIFY})
CreateConVar("cstm_att_aimpoint", "0", {FCVAR_REPLICATED, FCVAR_ARCHIVE, FCVAR_NOTIFY})
CreateConVar("cstm_att_acog", "0", {FCVAR_REPLICATED, FCVAR_ARCHIVE, FCVAR_NOTIFY})
CreateConVar("cstm_att_reflex", "0", {FCVAR_REPLICATED, FCVAR_ARCHIVE, FCVAR_NOTIFY})
CreateConVar("cstm_att_vertgrip", "0", {FCVAR_REPLICATED, FCVAR_ARCHIVE, FCVAR_NOTIFY})
CreateConVar("cstm_att_m203", "0", {FCVAR_REPLICATED, FCVAR_ARCHIVE, FCVAR_NOTIFY})
CreateConVar("cstm_att_bipod", "0", {FCVAR_REPLICATED, FCVAR_ARCHIVE, FCVAR_NOTIFY})
CreateConVar("cstm_att_lasersight", "0", {FCVAR_REPLICATED, FCVAR_ARCHIVE, FCVAR_NOTIFY})
CreateConVar("cstm_att_cmag", "0", {FCVAR_REPLICATED, FCVAR_ARCHIVE, FCVAR_NOTIFY})

SetGlobalFloat("CR", GetConVarNumber("cstm_recoilmod")) -- I'm sorry, but I have to use a global ;_;
umsg.PoolString("NWATT2")
umsg.PoolString("NWAlpha")
umsg.PoolString("NWSPD")
umsg.PoolString("NWHT")
umsg.PoolString("NBUL")
umsg.PoolString("FRMD")
umsg.PoolString("RECOIL")
umsg.PoolString("PICKUPATT")
umsg.PoolString("PICKUPATTSIL")
umsg.PoolString("GETATTS")
umsg.PoolString("REMATT")

local wep, wepclass, CT, distance, FinalDamageDecay, Accuracy, Accuracy2, Recoil, Damage

local function TWeps_Think()
	for k, v in pairs(player.GetAll()) do
		wep = v:GetActiveWeapon()
		CT = CurTime()
		
		if v:Alive() and ValidEntity(wep) then
			wepclass = wep:GetClass()
			
			if wepclass:find("^cstm_") then
				if v:OnGround() then
					if v:KeyDown(IN_SPEED) and v:GetVelocity():Length() > v:GetWalkSpeed() * 0.8 then
						wep.ReloadTime = nil
						
						if not wepclass:find("^cstm_pistol_") then
							if wepclass != "cstm_sniper_awp" then
								wep:SetNextPrimaryFire(CT + 0.3)
								wep:SetNextSecondaryFire(CT + 0.3)
							end
						end
					
						if wep.LastMag == 0 and wep.ShouldBolt == false then
							return
						end
					
						wep:SendWeaponAnim(wep.IdleAnim or ACT_VM_IDLE)
						wep.ShouldBolt = false
						wep.ReloadDelay = CT + 0.3
					end
				end
			end
		end
		
		if v:HasWeapon("test_medkit") then
			wep = v:GetWeapon("test_medkit")
			
			if CT > wep.IncreaseDelay then
				wep.dt.progress = math.Clamp(wep.dt.progress + 1, 0, 100)
				wep.IncreaseDelay = CT + 0.1
			end
		end
	end
end

hook.Add("Think", "TWeps_Think", TWeps_Think)

local function TWeps_KeyRelease(ply, key)
	if ply:Alive() then
		wep = ply:GetActiveWeapon()
		
		if wep != NULL and wep:GetClass():find("^cstm_") then
			if ply:GetVelocity():Length() >= ply:GetWalkSpeed() * 0.8 then
				if key == IN_SPEED then
					CT = CurTime()
				
					if wep:GetClass() != "cstm_sniper_awp" then
						wep:SetNextPrimaryFire(CT + 0.3)
						wep:SetNextSecondaryFire(CT + 0.3)
					end
					
					if wep.LastMag == 0 and wep.ShouldBolt == false then
						return
					end
				
					wep.ReloadDelay = CT + 0.3
				end
			end
		end
	end
end

hook.Add("KeyRelease", "TWeps_KeyRelease", TWeps_KeyRelease)

local function TWeps_EntityTakeDamage(victim, inflictor, attacker, amount, dmginfo)
	if not ValidEntity(victim) or not ValidEntity(attacker) or not attacker:IsPlayer() or not ValidEntity(attacker:GetActiveWeapon()) then
		return
	end
	
	if not dmginfo:GetDamageType() == DMG_BURN then
		return
	end
	
	wep = attacker:GetActiveWeapon()
			
	if wep.IsCustomWeapon then
		if wep.EffectiveRange then
			distance = attacker:GetPos():Distance(victim:GetPos())
			
			if victim:IsPlayer() and victim:Armor() > 0 then
				if wep:GetDTInt(2) == 2 then
					attacker.DamageAff1 = 0.3
				elseif wep:GetDTInt(2) == 3 then
					attacker.DamageAff1 = -0.3
				else
					attacker.DamageAff1 = 0
				end
			elseif victim:IsPlayer() and victim:Armor() <= 0 then
				if wep:GetDTInt(2) == 2 then
					attacker.DamageAff1 = -0.3
				elseif wep:GetDTInt(2) == 3 then
					attacker.DamageAff1 = 0.3
				else
					attacker.DamageAff1 = 0
				end
			else -- if he is an NPC then do the same as if he wouldn't have armor/etc.
				if wep:GetDTInt(2) == 2 then
					if victim:IsNPC() then
						attacker.DamageAff1 = -0.3
					else
						attacker.DamageAff1 = 0.3 -- breakable stuff should get extra damage
					end
				elseif wep:GetDTInt(2) == 3 then
					if victim:IsNPC() then
						attacker.DamageAff1 = 0.3
					else
						attacker.DamageAff1 = -0.3 -- breakable stuff should get less damage
					end
				else
					attacker.DamageAff1 = 0
				end
			end
			

			dmginfo:ScaleDamage(1 + attacker.DamageAff1) -- scale the damage with ammo types
			
			FinalDamageDecay = nil
			
			if distance >= wep.EffectiveRange then
				FinalDamageDecay = wep.DamageDecay
			else
				FinalDamageDecay = wep.DamageDecay * (distance / wep.EffectiveRange)
			end
			
			dmginfo:ScaleDamage(1 - FinalDamageDecay)
		end
	end
end

hook.Add("EntityTakeDamage", "TWeps_EntityTakeDamage", TWeps_EntityTakeDamage)

local eot, aim, acog, reflex, grip, m203, bipod, laser, cmag 
local mc = math.Clamp
local gcc = game.ConsoleCommand

local function TWeps_ApplyChanges(ply)
	if not ply:IsAdmin() then
		return
	end

	Accuracy = mc(tonumber(ply:GetInfo("cstm_accuracymod_aim_cl")), 0.2, 2)
	Accuracy2 = mc(tonumber(ply:GetInfo("cstm_accuracymod_hip_cl")), 0.2, 2)
	Recoil = mc(tonumber(ply:GetInfo("cstm_recoilmod_cl")), 0.2, 2)
	Damage = mc(tonumber(ply:GetInfo("cstm_damagemod_cl")), 0.2, 2)
	
	eot = mc(tonumber(ply:GetInfo("cstm_att_eotech_cl")), 0, 1)
	aim = mc(tonumber(ply:GetInfo("cstm_att_aimpoint_cl")), 0, 1)
	acog = mc(tonumber(ply:GetInfo("cstm_att_acog_cl")), 0, 1)
	reflex = mc(tonumber(ply:GetInfo("cstm_att_reflex_cl")), 0, 1)
	grip = mc(tonumber(ply:GetInfo("cstm_att_vertgrip_cl")), 0, 1)
	m203 = mc(tonumber(ply:GetInfo("cstm_att_m203_cl")), 0, 1)
	bipod = mc(tonumber(ply:GetInfo("cstm_att_bipod_cl")), 0, 1)
	laser = mc(tonumber(ply:GetInfo("cstm_att_lasersight_cl")), 0, 1)
	cmag = mc(tonumber(ply:GetInfo("cstm_att_cmag_cl")), 0, 1)
	
	gcc("cstm_accuracymod_aim " .. Accuracy .. "\n")
	gcc("cstm_accuracymod_hip " .. Accuracy2 .. "\n")
	gcc("cstm_recoilmod " .. Recoil .. "\n")
	gcc("cstm_damagemod " .. Damage .. "\n")
	SetGlobalFloat("CR", Recoil)
	
	gcc("cstm_att_eotech " .. eot .. "\n")
	gcc("cstm_att_aimpoint " .. aim .. "\n")
	gcc("cstm_att_acog " .. acog .. "\n")
	gcc("cstm_att_reflex " .. reflex .. "\n")
	gcc("cstm_att_vertgrip " .. grip .. "\n")
	gcc("cstm_att_m203 " .. m203 .. "\n")
	gcc("cstm_att_bipod " .. bipod .. "\n")
	gcc("cstm_att_lasersight " .. laser .. "\n")
	gcc("cstm_att_cmag " .. cmag .. "\n")
end

concommand.Add("cstm_applychanges", TWeps_ApplyChanges)

local function TWeps_ResetSettings(ply)
	if not ply:IsAdmin() then
		return
	end

	gcc("cstm_accuracymod_aim 1\n")
	gcc("cstm_accuracymod_hip 1\n")
	gcc("cstm_recoilmod 1\n")
	gcc("cstm_damagemod 1\n")
	
	gcc("cstm_att_eotech 0\n")
	gcc("cstm_att_aimpoint 0\n")
	gcc("cstm_att_acog 0\n")
	gcc("cstm_att_reflex 0\n")
	gcc("cstm_att_vertgrip 0\n")
	gcc("cstm_att_m203 0\n")
	gcc("cstm_att_bipod 0\n")
	gcc("cstm_att_lasersight 0\n")
	gcc("cstm_att_cmag 0\n")
	
	ply:ConCommand("cstm_accuracymod_aim_cl 1")
	ply:ConCommand("cstm_accuracymod_hip_cl 1")
	ply:ConCommand("cstm_recoilmod_cl 1")
	ply:ConCommand("cstm_damagemod_cl 1")
	
	ply:ConCommand("cstm_att_eotech_cl 0")
	ply:ConCommand("cstm_att_aimpoint_cl 0")
	ply:ConCommand("cstm_att_acog_cl 0")
	ply:ConCommand("cstm_att_reflex_cl 0")
	ply:ConCommand("cstm_att_vertgrip_cl 0")
	ply:ConCommand("cstm_att_m203_cl 0")
	ply:ConCommand("cstm_att_bipod_cl 0")
	ply:ConCommand("cstm_att_lasersight_cl 0")
	ply:ConCommand("cstm_att_cmag_cl 0")
	SetGlobalFloat("CR", 1)
end

concommand.Add("cstm_resetsettings", TWeps_ResetSettings)

local s

local function TWeps_PlayerSpawn(ply)
	ply.Attachments = {}
	SendUserMessage("REMATT", ply)
	
	s = ""
	
	if GetConVarNumber("cstm_att_eotech") >= 1  then
		s = s .. " eotech"
		table.insert(ply.Attachments, "eotech")
	end
	
	if GetConVarNumber("cstm_att_aimpoint") >= 1 then
		s = s .. " aimpoint"
		table.insert(ply.Attachments, "aimpoint")
	end
	
	if GetConVarNumber("cstm_att_acog") >= 1 then
		s = s .. " acog"
		table.insert(ply.Attachments, "acog")
	end
	
	if GetConVarNumber("cstm_att_reflex") >= 1 then
		s = s .. " reflex"
		table.insert(ply.Attachments, "reflex")
	end
	
	if GetConVarNumber("cstm_att_vertgrip") >= 1 then
		s = s .. " vertgrip"
		table.insert(ply.Attachments, "vertgrip")
	end
	
	if GetConVarNumber("cstm_att_m203") >= 1 then
		s = s .. " grenadelauncher"
		table.insert(ply.Attachments, "grenadelauncher")
	end
	
	if GetConVarNumber("cstm_att_bipod") >= 1 then
		s = s .. " bipod"
		table.insert(ply.Attachments, "bipod")
	end
	
	if GetConVarNumber("cstm_att_lasersight") >= 1 then
		s = s .. " laser"
		table.insert(ply.Attachments, "laser")
	end
	
	if GetConVarNumber("cstm_att_cmag") >= 1 then
		s = s .. " cmag"
		table.insert(ply.Attachments, "cmag")
	end
	
	if s != "" then
		umsg.Start("GETATTS", ply)
			umsg.String(s)
		umsg.End()
	end
end

hook.Add("PlayerSpawn", "TWeps_PlayerSpawn", TWeps_PlayerSpawn)

local PLY = _R.Player

function PLY:PickUpAttachment(att, sil)
	table.insert(self.Attachments, att)
	
	if sil then
		umsg.Start("PICKUPATTSIL", self)
			umsg.String(att)
		umsg.End()
	else
		umsg.Start("PICKUPATT", self)
			umsg.String(att)
		umsg.End()
	end
end