include("shared.lua")

function ENT:Initialize()
	self.Entity.ParticleTime = 0
end

function ENT:Draw()
	self.Entity:DrawModel()
end

function ENT:Think()
	if CurTime() > self.Entity.ParticleTime then
		local forward = self.Entity:GetForward()
		ParticleEffect("cstm_frag_fly", self.Entity:GetPos(), self.Entity:GetAngles(), nil)
		self.Entity.ParticleTime = CurTime() + 0.015
	end
		
	local dlight = DynamicLight(self:EntIndex())
		
	if dlight then
		dlight.Pos = self:GetPos()
		dlight.r = 255
		dlight.g = 255
		dlight.b = 100
		dlight.Brightness = 2
		dlight.Size = 128
		dlight.Decay = 128 * 3
		dlight.DieTime = CurTime() + 0.1
	end
end 