AddCSLuaFile("cl_init.lua")
AddCSLuaFile("shared.lua")
include("shared.lua")

function ENT:Initialize()
	self:SetModel("models/Items/BoxMRounds.mdl") 
	self:PhysicsInit(SOLID_VPHYSICS)
	self:SetMoveType(MOVETYPE_VPHYSICS)
	self:SetSolid(SOLID_VPHYSICS)
	self:SetCollisionGroup(COLLISION_GROUP_NPC)
	local phys = self:GetPhysicsObject()

	if phys and phys:IsValid() then
		phys:Wake()
	end
end

function ENT:SpawnFunction( ply, tr )
    if ( !tr.Hit ) then return end
	
    local ent = ents.Create("upgr_ammo_masher")
    ent:SetPos( tr.HitPos + tr.HitNormal * 16 ) 
    ent:Spawn()
    ent:Activate()
 
    return ent
end

function ENT:OnTakeDamage(dmginfo)
	self:GetPhysicsObject():AddVelocity(dmginfo:GetDamageForce() * 0.1)
end

local wep, vm, seqdur, ct

function ENT:Use(activator, caller)
	if activator:IsPlayer() then
		wep = activator:GetActiveWeapon()
		vm = activator:GetViewModel()
		seqdur = vm:SequenceDuration()
	
		if CurTime() > wep.ReloadDelay then
			if wep:GetClass():find("^cstm_") and wep.HasMasher then
				if wep:GetDTInt(2) != 7 then
					CT = CurTime()
					
					wep:SetDTInt(2, 7)
					wep.Primary.NumShots = 12
					wep.Primary.Damage = wep.Primary.Damage / 8
					wep.IronsightsCone = wep.IronsightsCone * 1.4
					wep.HipCone = wep.HipCone * 1.4
					wep:SendWeaponAnim(ACT_VM_RELOAD)
					wep:SetNextPrimaryFire(CT + seqdur)
					wep:SetNextSecondaryFire(CT + seqdur)
					wep.ReloadDelay = CT + seqdur
					wep:SetClip1(wep.Primary.ClipSize)
					activator:SetAnimation(PLAYER_RELOAD)
					
					umsg.Start("NBUL", activator)
						umsg.Short(12)
					umsg.End()
					
					self:Remove()
				end
			end
		end
	end
end

function ENT:OnRemove()
return false
end 