AddCSLuaFile("cl_init.lua")
AddCSLuaFile("shared.lua")
include("shared.lua")

function ENT:Initialize()
	self:SetModel("models/Items/BoxMRounds.mdl") 
	self:PhysicsInit(SOLID_VPHYSICS)
	self:SetMoveType(MOVETYPE_VPHYSICS)
	self:SetSolid(SOLID_VPHYSICS)
	self:SetCollisionGroup(COLLISION_GROUP_NPC)
	local phys = self:GetPhysicsObject()

	if phys and phys:IsValid() then
		phys:Wake()
	end
end

function ENT:SpawnFunction( ply, tr )
    if ( !tr.Hit ) then return end
	
    local ent = ents.Create("upgr_ammo_normal")
    ent:SetPos( tr.HitPos + tr.HitNormal * 16 ) 
    ent:Spawn()
    ent:Activate()
 
    return ent
end

function ENT:OnTakeDamage(dmginfo)
	self:GetPhysicsObject():AddVelocity(dmginfo:GetDamageForce() * 0.1)
end

local wep, vm, seqdur, dt2, CT

function ENT:Use(activator, caller)
	if activator:IsPlayer() then
		wep = activator:GetActiveWeapon()
		vm = activator:GetViewModel()
		seqdur = vm:SequenceDuration()
	
		if CurTime() > wep.ReloadDelay then
			if wep:GetClass():find("^cstm_") and not wep:GetClass():find("^test_pistol") then
				dt2 = wep:GetDTInt(2)
				
				if dt2 != 0 then
					if dt2 == 4 then
						wep.Primary.Recoil = wep.Primary.Recoil / 1.25
						wep.Primary.Damage = wep.Primary.Damage / 1.2
					elseif dt2 == 7 then
						wep.Primary.NumShots = 1
						wep.Primary.Damage = wep.Primary.Damage * 8
						wep.IronsightsCone = wep.IronsightsCone / 1.4
						wep.HipCone = wep.HipCone / 1.4
						
						umsg.Start("NBUL", activator)
							umsg.Short(1)
						umsg.End()
					end
				
					wep:SetDTInt(2, 0)
					
					if not wep:GetClass():find("^cstm_shotgun_") then
						if wep.Base == "cstm_base_xtra_pistol" then
							if wep.IsSilenced then
								wep:SendWeaponAnim(ACT_VM_RELOAD_SILENCED)
							else
								wep:SendWeaponAnim(ACT_VM_RELOAD)
							end
						else
							wep:SendWeaponAnim(ACT_VM_RELOAD)
						end
						
						CT = CurTime()
						
						wep:SetNextPrimaryFire(CT + seqdur)
						wep:SetNextSecondaryFire(CT + seqdur)
						wep.ReloadDelay = CT + seqdur
						wep:SetClip1(wep.Primary.ClipSize)
						activator:SetAnimation(PLAYER_RELOAD)
					end
					
					self:Remove()
				end
			end
		end
	end
end

function ENT:OnRemove()
return false
end 