

if ( SERVER ) then

	AddCSLuaFile( "shared.lua" )
	SWEP.HasRail = true
	SWEP.NoAimpoint = true
	SWEP.NoACOG = true
	SWEP.NoEOTech = true
	SWEP.NoDocter = true
	
	SWEP.BulletLength = 9
	SWEP.CaseLength = 19
	SWEP.RequiresRail = false
	SWEP.NoLaser = true
end

if ( CLIENT ) then

	SWEP.PrintName			= "Dual M9 Elites"			
	SWEP.Author				= "Counter-Strike"
	SWEP.Slot				= 1
	SWEP.SlotPos			= 1
	SWEP.IconLetter			= "s"
	SWEP.Muzzle = "cstm_muzzle_pistol"
	SWEP.SparkEffect = "cstm_child_sparks_small"
	SWEP.SmokeEffect = "cstm_child_smoke_small"
	
	killicon.AddFont( "cstm_pistol_dualelites", "CSKillIcons", SWEP.IconLetter, Color( 255, 80, 0, 255 ) )
	
	SWEP.NoProperIronsights = true
	
end

SWEP.Base				= "cstm_base_pistol"
///SWEP.Category			= "Condition SWEPs (TEST)"

SWEP.Spawnable			= false
SWEP.AdminSpawnable		= false

SWEP.HoldType = "pistol"
SWEP.ViewModelFOV = 70
SWEP.ViewModelFlip = false
SWEP.ViewModel = "models/weapons/v_pist_elite.mdl"
SWEP.WorldModel = "models/weapons/w_pist_deagle.mdl"
SWEP.ShowViewModel = true
SWEP.ShowWorldModel = false
SWEP.ViewModelBonescales = {}

SWEP.Weight				= 5
SWEP.AutoSwitchTo		= false
SWEP.AutoSwitchFrom		= false

SWEP.Primary.Sound			= Sound("weapons/elite/elite-1.wav")
SWEP.Primary.Recoil			= 3
SWEP.Primary.Damage			= 15
SWEP.Primary.NumShots		= 1
SWEP.Primary.Cone			= 0.02
SWEP.Primary.ClipSize		= 30
SWEP.Primary.Delay			= 0.11
SWEP.Primary.DefaultClip	= 30
SWEP.Primary.Automatic		= false
SWEP.Primary.Ammo			= "pistol"
SWEP.InitialHoldtype = "pistol"
SWEP.InHoldtype = "pistol"
SWEP.NoAuto = true
SWEP.ACOGStatus = 0
SWEP.NoScopes = true
SWEP.NoBoltAnim = true
SWEP.ChamberAmount = 2

-- Animation speed/custom reload function related
SWEP.IsReloading = false
SWEP.AnimPrefix = ""
SWEP.ReloadSpeed = 1
SWEP.ShouldBolt = false
SWEP.ReloadDelay = 0
SWEP.IncAmmoPerc = 0.28 -- Amount of frames required to pass (in percentage) of the reload animation for the weapon to have it's amount of ammo increased

-- Dynamic accuracy related
SWEP.ShotsAmount 			= 0
SWEP.ConeDecAff				= 0
SWEP.DefRecoil				= 0.8
SWEP.CurCone				= 0.04
SWEP.DecreaseRecoilTime 	= 0
SWEP.ConeAff1 				= 0 -- Crouching/standing
SWEP.ConeAff2 				= 0 -- Using ironsights
SWEP.ViewPunchCycle 		= 0
SWEP.ViewPunchDelay			= 0
SWEP.WalkPunchCycle			= 0
SWEP.WalkPunchDelay 		= 0
SWEP.UnConeTime				= 0 -- Amount of time after firing the last shot that needs to pass until accuracy increases
SWEP.FinalCone				= 0 -- Self explanatory
SWEP.VelocitySensivity		= 1 -- Percentage of how much the cone increases depending on the player's velocity (moving speed). Rifles - 100%; SMGs - 80%; Pistols - 60%; Shotguns - 20%
SWEP.HeadbobMul 			= 1
SWEP.IsSilenced 			= false
SWEP.IronsightsCone 		= 0.032
SWEP.HipCone 				= 0.038
SWEP.ConeInaccuracyAff1 = 0.5

SWEP.Secondary.Automatic	= false
SWEP.Secondary.Ammo			= "none"

SWEP.IsUsingIronsights 		= false
SWEP.TargetMul = 0
SWEP.SetAndForget			= false

SWEP.AnimCyc = 1

SWEP.IronSightsPos = Vector(6.0749, -5.5216, 2.3984)
SWEP.IronSightsAng = Vector(2.5174, -0.0099, 0)

SWEP.AimPos = Vector(-0.24, -1.803, 2.319)
SWEP.AimAng = Vector(0, 0, 0)

SWEP.ChargePos = Vector (5.4056, -10.3522, -4.0017)
SWEP.ChargeAng = Vector (-1.7505, -55.5187, 68.8356)

SWEP.ReflexPos = Vector(5.125, -3.089, 2.361)
SWEP.ReflexAng = Vector(0, 0, 0)

SWEP.MeleePos = Vector(0.843, -0.956, 0.537)
SWEP.MeleeAng = Vector(0, 8.1, 0)

SWEP.NoFlipOriginsPos = Vector(0, 0, 0)
SWEP.NoFlipOriginsAng = Vector(0, 0, 0)

local CT, RecMod, vm, act, muz, muz2, wep, par, ply, bullet, dt3
local clamp, rand = math.Clamp, math.random

function SWEP:PrimaryAttack()
	if self.ShouldBolt == true or self.IsReloading == true then
		return
	end
	
	dt3 = self:GetDTInt(3)
	
	if dt3 == 2 then
		return
	end
	
	CT = CurTime()
	clip = self:Clip1()
	
	if (clip == 0 or self.Owner:WaterLevel() == 3) and not self.Grenade then
		self:EmitSound("weapons/shotgun/shotgun_empty.wav", 65, rand(99, 101))
		self:SetNextSecondaryFire( CT + 0.05 )
		self:SetNextPrimaryFire( CT + 0.25 )
		return
	end
	
	self:SetNextSecondaryFire( CT + self.Primary.Delay )
	self:SetNextPrimaryFire( CT + self.Primary.Delay )
	
	if ( !self:CanPrimaryAttack() ) then return end
	
	self:TakePrimaryAmmo( 1 )
	
	if SERVER then
		if not self.dt.Sil then
			self.Owner:EmitSound(self.Primary.Sound, self.UnsilencedVolume, rand(99, 101))
		else
			self.Owner:EmitSound(self.SilencedSound, self.SilencedVolume, rand(99, 101))
		end
		
		if clip <= 10 then
			self.Owner:EmitSound("weapons/ClipEmpty_Rifle.wav", 60 - (clip * 4), 100)
		end
		
		if SinglePlayer() then
			SendUserMessage("RECOIL", self.Owner)
		end
	end
	
	self.ReloadDelay = CT + 0.5
	self.Owner.AttachDelay = CT + 0.5
	self.MeleeDelay = CT + 0.3
	
	RecMod = GetGlobalFloat("CR")
	
	if dt3 != 1 then
		self:CSShootBullet( self.Primary.Damage, self.Primary.Recoil * 1.2 * RecMod, self.Primary.NumShots, self:GetDTFloat(0))
		self:Recoil(self.Primary.Recoil * 1.2 * RecMod)
	else
		self:CSShootBullet( self.Primary.Damage, self.Primary.Recoil * 0.75 * RecMod, self.Primary.NumShots, self:GetDTFloat(0))
		self:Recoil(self.Primary.Recoil * 0.75 * RecMod)
	end
	
	if CLIENT then
		if dt3 == 1 then
			self.RecoilAmt = 2.5
			self:MuzzleFlosh()
		end
	end
	
	self.Owner:ViewPunch( Angle(-1 * (self.Primary.Recoil + self.ConeInaccuracy * 4) * (1 - (self.RecoilAff1 + self.RecoilAff2 + self.RecoilAff3)), 0, 0 ) * RecMod )
	
	self.ConeInaccuracy = clamp(self.ConeInaccuracy + (0.005 + self.DefRecoil * (0.006 - (self.ConeDecAff1 + self.ConeDecAff2))) * self.InaccAff1, 0, 0.12 * (self.ConeInaccuracyAff1))
	self.ConeInaccDelay = CT + self.Primary.Delay * 1.05
	
	if ( self.Owner:IsNPC() ) then return end
end

if CLIENT then
	function SWEP:FireAnimationEvent(pos, ang, ev)
		if ev == 5001 then
			if not self.Owner:ShouldDrawLocalPlayer() then
				self:MuzzleFlosh()
				
				return ev == 5001
			end
		end
	end
	
	function SWEP:MuzzleFlosh() -- lololol
		vm = self.Owner:GetViewModel()
		act = self:GetSequenceActivityName(self:GetSequence())
		
		muz, muz2 = nil, nil
		
		if act == "ACT_VM_PRIMARYATTACK" then
			muz = vm:GetAttachment("2")
			muz2 = vm:LookupAttachment("2")
		else
			muz = vm:GetAttachment("1")
			muz2 = vm:LookupAttachment("1")
		end
				
		if not self.Em then
			self.Em = ParticleEmitter(muz.Pos)
		end
				
		if GetConVarNumber("cstm_ef_smoke") > 0 then
			ParticleEffect(self.SmokeEffect or "cstm_child_smoke_small", muz.Pos, self.Owner:EyeAngles(), muz)
		end
				
		if self.Silenced == true or self.Silenced == 1 then
			return
		end
		
		if (self.VElements and self.VElements["silencer"] != nil and self.Owner:GetActiveWeapon().VElements["silencer"].color.a != 255) or self.VElements and self.VElements["silencer"] == nil then -- I check if it's not nil and then if it's nil to ensure that weapons that don't have a silencer don't bug
				
			if GetConVarNumber("cstm_ef_heat") > 0 then
				par = self.Em:Add("sprites/heatwave", muz.Pos)
				par:SetStartSize(4)
				par:SetEndSize(1)
				par:SetDieTime(0.3)
			end
				
			if GetConVarNumber("cstm_ef_extramuzzle") > 0 then
				ParticleEffectAttach(self.Muzzle or "cstm_muzzle_pistol", PATTACH_POINT_FOLLOW, vm, muz2)
			end
					
			if GetConVarNumber("cstm_ef_sparks") > 0 then
				ParticleEffectAttach(self.SparkEffect or "cstm_child_sparks_small", PATTACH_POINT_FOLLOW, vm, muz2)
			end
	
		end
	end
	
	function SWEP:BoneReposFunc(ply, numbon, numphysbon)
		ply = LocalPlayer()
		wep = ply:GetActiveWeapon()
		
		if ValidEntity(wep) then
			if wep.WElements and wep.WElements.BaseClass then
				wep.WElements.BaseClass = nil
			end
			
			if wep.ReposMyBones and wep.BonesToRepos then
				for k, v in pairs(wep.BonesToRepos) do
					local bone = ply:LookupBone(k)
					local matrix = ply:GetBoneMatrix(bone)
					
					if matrix then
						matrix:Rotate(v.ang)
						ply:SetBoneMatrix(bone, matrix)
					end
				end
			end
		end
	end
end

function SWEP:CSShootBullet( dmg, recoil, numbul, cone )
	numbul 	= numbul 	or 1
	cone 	= cone 		or 0.01
		
	/*local offset
	
	if self:GetDTInt(3) == 10 then
		offset = self.Owner:EyeAngles():Right() * 10
	elseif self:GetDTInt(3) == 11 then
		offset = self.Owner:EyeAngles():Right() * -10
	elseif self:GetDTInt(3) == 12 then
		offset = self.Owner:EyeAngles():Up() * 10
	else
		offset = Vector(0, 0, 0)
	end*/
		
	bullet = {}
	bullet.Num 		= numbul
	bullet.Src 		= self.Owner:GetShootPos() //+ offset		// Source
	bullet.Dir 		= ( self.Owner:EyeAngles() + self.Owner:GetPunchAngle() ):Forward()		// Dir of bullet
	bullet.Spread 	= Vector( cone, cone, 0 )			// Aim Cone
	bullet.Tracer	= 4									// Show a tracer on every x bullets 
	bullet.Force	= self.Primary.Damage									// Amount of force to give to phys objects
	if self.IsSilenced then
		damagemod1 = 0.1
	else
		damagemod1 = 0
	end
	
	if self:GetDTInt(2) == 1 then
		damagemod2 = 0.3
	else
		damagemod2 = 0
	end
	
	bullet.Damage = math.Round((self.Primary.Damage * (1 - (damagemod1 + damagemod2 ))) * GetConVarNumber("cstm_damagemod"))
	
	bullet.Callback = function(attacker, trace, dmginfo)
		if SERVER and self:GetDTInt(2) == 1 then
			if ValidEntity(trace.Entity) then
				trace.Entity:Ignite(6)
			end
		end
		
		--[[local penetrationForce
		local hitMat = trace.MatType 
		
		if hitMat == MAT_PLASTIC then
			penetrationForce = 1.25
		elseif hitMat == MAT_WOOD then
			penetrationForce = 1
		elseif hitMat == MAT_TILE then
			penetrationForce = 0.75
		elseif hitMat == MAT_CONCRETE then
			penetrationForce = 0.5
		elseif hitMat == MAT_METAL or hitMat == MAT_VENT then
			penetrationForce = 0.5
		else
			penetrationForce = 1
		end
		
		local forward = bullet.Dir:Normalize()
		local tr = {}
		tr.start = trace.HitPos
		tr.endpos = tr.start
		tr.filter = self
		
		local trace2 = util.TraceLine(tr)
		
		if not trace2.HitWorld and trace.Entity != trace2.Entity then
			local bullet2 = {}
			bullet2.Num = bullet.Num
			bullet2.Src = trace.HitPos + forward * 8 * penetrationForce
			bullet2.Dir = bullet.Dir
			bullet2.Spread = Vector(0, 0, 0)
			bullet2.Tracer = bullet.Tracer
			bullet2.Force = bullet.Force * 0.5
			bullet2.Damage = bullet.Damage * 0.5
			//ParticleEffect("cstm_penetration_smoke", trace.HitPos + (forward * 4) * penetrationForce, Angle(0, 0, 0), nil)
			
			if SERVER then
				self.Owner:LagCompensation(false)
			end
			
			self.Owner:FireBullets(bullet2)
		end]]--
		
	end
	
	self.Owner:FireBullets(bullet)
	
	local eff
	
	if self.AnimCyc == 1 then
		self:SendWeaponAnim(ACT_VM_PRIMARYATTACK)
		self.AnimCyc = 2
		eff = "ef_muzzle_right"
	elseif self.AnimCyc == 2 then
		self:SendWeaponAnim(ACT_VM_SECONDARYATTACK)
		self.AnimCyc = 1
		eff = "ef_muzzle_left"
	end
	
	if not SinglePlayer() then
		local ef = EffectData()
		ef:SetOrigin(self.Owner:GetShootPos())
		ef:SetEntity(self.Weapon)
		ef:SetAngle(self.Owner:GetAngles())
		util.Effect(eff, ef)
	end
	
	self.Owner:GetViewModel():SetPlaybackRate(self.PlaybackRate or 1) -- some weapons in the pack have slow recoil animation, so I've decided to slightly speed it up
	
	if ( self.Owner:IsNPC() ) then return end
	
	// CUSTOM RECOIL !
end

