if (SERVER) then
	AddCSLuaFile( "shared.lua" )
	SWEP.Weight				= 5
	SWEP.AutoSwitchTo		= false
	SWEP.AutoSwitchFrom		= false
	SWEP.ScopeStatus = 0
	SWEP.LastMag = 0
	SWEP.NoGL = true
	SWEP.SecondaryAtt = 0
	SWEP.GrenadeType = "gren_explosive"
	SWEP.BlastRadius = 256
	SWEP.BlastDamage = 80
	SWEP.Grenade = false
	SWEP.RailType = 1
	SWEP.CanAimWithRail = false
	SWEP.EoTechWithRail = false
	SWEP.NoVertGrip = true
	SWEP.NoCMag = true
	SWEP.NoBipod = true
	SWEP.MeleeDelay = 0
	SWEP.IsCustomWeapon = true
	SWEP.RequiresRail = true
end

if ( CLIENT ) then
	SWEP.OffsetBones = {}
	SWEP.IsCustomWeapon = true
	
	SWEP.DrawAmmo			= true
	SWEP.DrawCrosshair		= false
	SWEP.ViewModelFOV		= 70
	SWEP.ViewModelFlip		= true
	SWEP.CSMuzzleFlashes	= true
	SWEP.DrawWeaponInfoBox  = true
	SWEP.HasInstalledScope  = false
	SWEP.TimeToStartOffset = 0
	SWEP.PitchMod = 1
	SWEP.RollMod = 1
	SWEP.EoTechWithRail = false
	SWEP.BoneApproachSpeed = 0.3
	SWEP.RecoilAmt = 0
	SWEP.LaserTune = {
		PosRight = 0,
		PosForward = 0,
		PosUp = 0,
		AngUp = -90,
		AngRight = 0,
		AngForward = 0 }
		
	// This is the font that's used to draw the death icons
	surface.CreateFont( "csd", ScreenScale( 30 ), 500, true, true, "CSKillIcons" )
	surface.CreateFont( "csd", ScreenScale( 60 ), 500, true, true, "CSSelectIcons" )
	
	language.Add("striderminigun_ammo", "7.62x39MM Ammo")
	language.Add("combinecannon_ammo", ".50AE Ammo")
	language.Add("airboatgun_ammo", "5.56x45MM NATO Ammo")
	language.Add("sniperround_ammo", ".338 Lapua Magnum Ammo")
	language.Add("sniperpenetratedround_ammo", "7.62x51MM NATO Ammo")
	language.Add("alyxgun_ammo", "5.7x28MM Ammo")
	language.Add("helicoptergun_ammo", ".45 ACP Ammo")
	
	function SWEP:IsActiveCModel(m)
		if not self.VElements[m] then
			return false
		end
		
		if self.VElements[m].color.a != 255 then
			return false
		end
		
		return true
	end
end

SWEP.Author			= "LEETNOOB"
SWEP.Contact		= ""
SWEP.Purpose		= ""
SWEP.Instructions	= "PRIMARY ATTACK key to fire\nSECONDARY ATTACK key to toggle ironsights\nUSE key + SECONDARY ATTACK key - attach suppressor\nUSE key + RELOAD key - switch between semi-auto/auto firemodes (SMGs/ARs)\nCONTEXT MENU KEY - open attachment selection menu\nWHILE IN MENU - press numbers in brackets on the keyboard to select attachments"

// Note: This is how it should have worked. The base weapon would set the category
// then all of the children would have inherited that.
// But a lot of SWEPS have based themselves on this base (probably not on purpose)
// So the category name is now defined in all of the child SWEPS.
//SWEP.Category			= "Counter-Strike"

SWEP.Spawnable			= false
SWEP.AdminSpawnable		= false

SWEP.Primary.Sound			= Sound( "Weapon_AK47.Single" )
SWEP.Primary.Recoil			= 1.5
SWEP.Primary.Damage			= 40
SWEP.Primary.NumShots		= 1
SWEP.Primary.Cone			= 0.02
SWEP.Primary.Delay			= 0.15

SWEP.Primary.ClipSize		= -1
SWEP.Primary.DefaultClip	= -1
SWEP.Primary.Automatic		= false
SWEP.Primary.Ammo			= "none"

SWEP.Secondary.ClipSize		= -1
SWEP.Secondary.DefaultClip	= -1
SWEP.Secondary.Automatic	= false
SWEP.Secondary.Ammo			= "none"
SWEP.Base = "cmodel_cstm_base"
SWEP.Category = "Customizable weaponry"

SWEP.RunPos = Vector(-3.587, -11.735, -0.438)
SWEP.RunAng = Vector(0, -70, 0)

SWEP.RunPosPistol = Vector(0.328, -10.82, -4.621)
SWEP.RunAngPistol = Vector(70, 0, 0)

SWEP.RunPosNoFlip = Vector(3.443, -10.164, 0)
SWEP.RunAngNoFlip = Vector(0, 70, 0)

SWEP.FlipOriginsPos = Vector(3.305, -1.968, 0.735)
SWEP.FlipOriginsAng = Vector(0, 0, 0)

SWEP.NoFlipOriginsPos = Vector(-2.25, 0, -0.695)
SWEP.NoFlipOriginsAng = Vector(0, 0, 0)

SWEP.MeleePos = Vector(-2.945, -16.951, -6.206)
SWEP.MeleeAng = Vector(0, -90, 29.261)

SWEP.MeleePosNoFlip = Vector(3.769, -9.672, -7.049)
SWEP.MeleeAngNoFlip = Vector(28.688, 70, 0)

SWEP.AngleDelta = Angle(0, 0, 0)
SWEP.OldDelta = Angle(0, 0, 0)

SWEP.ConeAff3 = 0
SWEP.ConeInaccuracy = 0
SWEP.ConeInaccuracyDec = 0
SWEP.SilencedSound = Sound("weapons/usp/usp1.wav")
SWEP.SilencedVolume = 70
SWEP.UnsilencedVolume = 101
SWEP.ConeInaccuracyAff1 = 1
SWEP.RecoilAff1 = 0
SWEP.RecoilAff2 = 0
SWEP.RecoilAff3 = 0
SWEP.InaccAff1 = 1
SWEP.ConeInaccDelay = 0
SWEP.ConeDecAff1 = 0
SWEP.ConeDecAff2 = 0
SWEP.MeleeDamageMin = 10
SWEP.MeleeDamageMax = 15

/*---------------------------------------------------------
---------------------------------------------------------*/
function SWEP:Initialize()

	if ( SERVER ) then
		self:SetNPCMinBurst( 30 )
		self:SetNPCMaxBurst( 30 )
		self:SetNPCFireRate( 0.01 )
		
		if self.BulletLength and self.CaseLength then
			self.EffectiveRange = self.CaseLength * 10 - self.BulletLength * 5 -- setup realistic base effective range
			self.EffectiveRange = self.EffectiveRange / 2 -- halven it, because the maps aren't big enough and we want to balance shit out
			self.EffectiveRange = self.EffectiveRange * 39.37 -- convert meters to units
			self.DamageDecay = self.BulletLength / self.CaseLength -- setup the damage decay over distance in percentage
		end
	end
	
	self:SetWeaponHoldType(self.HoldType)
	self:SetDTInt(3, 0)
	self:SetDTFloat(0, 0)
	self:SetDTInt(2, 0)
	self.ReloadDelay = CurTime() + 0.1
	self.Primary.Recoil = self.DefRecoil
	self.Primary.ClipSize_Orig = self.Primary.ClipSize
	
    if CLIENT then
		self.AimPos_Orig = self.AimPos
		self.AimAng_Orig = self.AimAng
		
		if self.Primary.Automatic and not self.Burst then
			self.Bullets = 5
		elseif self.Primary.Automatic and self.Burst then
			self.Bullets = 3
		else
			self.Bullets = 1
		end
     
        self:CreateModels(self.VElements) // create viewmodels
        self:CreateModels(self.WElements) // create worldmodels
         
        // init view model bone build function
        /*self.BuildViewModelBones = function( s )
            if LocalPlayer():GetActiveWeapon() == self and self.ViewModelBonescales then
                for k, v in pairs( self.ViewModelBonescales ) do
                    local bone = s:LookupBone(k)
                    if (!bone) then continue end
                    local m = s:GetBoneMatrix(bone)
                    if (!m) then continue end
                    m:Scale(v)
                    s:SetBoneMatrix(bone, m)
                end
            end
        end*/
		
		/*self:GetViewModel().BuildBonePositions = function(self, numbon, numphysbon)
			local bone = self:GetViewModel():LookupBone("Right_U_Arm")
			local matrix = self:GetBoneMatrix(bone)
			
			if matrix then
				matrix:Translate(Vector(0, 0, -2))
				self:SetBoneMatrix(matrix)
			end
		end*/
         
		 
		if self.ReposMyBones and self.BonesToRepos then
			self.Owner.BuildBonePositions = self.BoneReposFunc
		end
    end
end

function SWEP:SetupDataTables()
	self:DTVar("Bool", self.IsSilenced, "Sil")
	self.dt.Sil = self.IsSilenced
end

local CT, nick, ammotype, clip, vm, mul, seqdur, ammo, AmountToReload, chamber, sequence, AimVec, wepclass, wep, activity, FT, bone, matrix, ply, m, ef, RecMod, bullet, eyeang, RS, Off, Off2, Right, Up, Forward, AttSoundDelay, attachent, attachent2, dlight, muz, muz2, number, Mode, Width, Height, x2, x3, y2, y3, Text, trace, coords, out_r, out_g, out_b, out_a, in_r, in_g, in_b, in_a, scale, cl, dtint3, fov, ScopeStatus, physobj, TimeRel, TimeIdle, time
local destr, tsim, app, clamp, sin, cos, rand, rand2 = timer.Destroy, timer.Simple, math.Approach, math.Clamp, math.sin, math.cos, math.random, math.Rand
local tr = {}

function SWEP:Deploy()
	CT = CurTime()

	self:SendWeaponAnim(ACT_VM_DRAW)
	self:SetNextPrimaryFire(CT + 1)
	self:SetNextSecondaryFire(CT + 1)
	self.ReloadDelay = CT + 1
	self.MeleeDelay = CT + 1
	
	if SERVER and SinglePlayer() then
		tsim(0, function()
			if ValidEntity(self) and self.Owner and self.Owner:Alive() then
				self.Owner:SendLua("local wep = LocalPlayer():GetActiveWeapon() wep:ResetSequence(wep:SelectWeightedSequence(ACT_VM_DRAW))")
			end
		end)
	end
	
	if CLIENT then
		self:ResetSequence(self:SelectWeightedSequence(ACT_VM_DRAW))
	end
	
	self:SetDTInt(3, 0)
	self.HolsterStatus = 0
	
	return true
end

local initial = false

function SWEP:Holster(weapon)
	if not ValidEntity(self.Owner) or not self.Owner:Alive() then
		return
	end
	
	CT = CurTime()
	
	if self:GetDTInt(3) != 6 then
		if CT < self.ReloadDelay then
			return false
		end
	end
	
	if self.HolsterStatus == 0 then
		self.HolsterStatus = 1
		self:SetDTInt(3, 6)
		self:SetNextPrimaryFire(CT + 0.4)
		self:SetNextSecondaryFire(CT + 0.4)
		self.ReloadDelay = CT + 0.4
		self:EmitSound("weapons/cstm/holster" .. math.random(1, 4) .. ".wav", 65, 100)
		
		timer.Simple(0.35, function()
			if not ValidEntity(self.Owner) or not ValidEntity(self) then
				return
			end

			self.Owner:GetViewModel().BuildBonePositions = nil
			self.ReloadTime = nil
			nick = self.Owner:Nick()
			destr("AmmoInc" .. nick)
			destr("ReloadLogic" .. nick)
			destr("ReloadTimer" .. nick)
			
			if CLIENT then
				self.OffsetMeStage = 1
				
				if self:GetOwner() == LocalPlayer() then
					if PAs then
						for k, v in pairs(PAs) do
							if ValidPanel(v) then
								v:Remove()
							end
						end
					end
				end
			end
			
			if SERVER then
				if ValidEntity(weapon) and self.Owner then
					self.Owner:SetFOV(0, 0.3)
					self.Owner:SelectWeapon(weapon:GetClass())
				end
			end
		end)
		
		return false
	end

	return true
end

function SWEP:Reload()
	if self.ReloadTime then
		return
	end
	
	if self:GetDTInt(3) == 19 then
		return
	end

	if self.HasReleasedKey == false or CurTime() < self.ReloadDelay then
		return
	end

	if self.Owner:KeyDown(IN_USE) then
		if self.NoAuto != true then
			if SERVER then
				if self.Primary.Automatic == true then
					self.Primary.Automatic = false
					self.Owner:EmitSound("weapons/smg1/switch_single.wav", 70, rand(99, 101))
					
					umsg.Start("FRMD", self.Owner)
						umsg.String("semi")
					umsg.End()
				else
					self.Primary.Automatic = true
					self.Owner:EmitSound("weapons/smg1/switch_burst.wav", 70, rand(99, 101))
					
					umsg.Start("FRMD", self.Owner)
						umsg.String("auto")
					umsg.End()
				end
			end
			
			self.HasReleasedKey = false
			self.ReloadDelay = CurTime() + 0.2
			return
		end
	end
	
	clip = self:Clip1()
	
	if self:GetDTInt(3) != 2 then
		if (not self.CantChamber and clip <= self.Primary.ClipSize) or (self.CantChamber and clip < self.Primary.ClipSize) then
			if self.Owner:GetAmmoCount(self.Primary.Ammo) > 0 then
				if CurTime() > self.ReloadDelay then
					if SERVER then
						if self.Owner:GetFOV() != 0 then
							self.Owner:SetFOV(0, 0.3)
							self.Owner:DrawViewModel(true)
							self.LastMag = clip
							
							if clip > 1 then
								ammotype = self:GetPrimaryAmmoType()
							
								if not self.CantChamber then
									self.Owner:SetAmmo(self.Owner:GetAmmoCount(ammotype) + clip - 1, ammotype)
									self:SetClip1(1)
								else
									self.Owner:SetAmmo(self.Owner:GetAmmoCount(ammotype) + clip, ammotype)
									self:SetClip1(0)
								end
							end
						end
					end
				
					self:SendWeaponAnim(ACT_VM_IDLE)
					self:StartCustomReload(self.ReloadSpeed)
					self.Owner:SetAnimation(PLAYER_RELOAD)
					self.AnimPlayed = false
					self:SetDTInt(3, 0)
				end
			end
		end
	end
end

function SWEP:StartCustomReload(animspeed)
	self:SendWeaponAnim(ACT_VM_RELOAD)
	vm = self.Owner:GetViewModel()
	vm:SetPlaybackRate(animspeed)
	
	clip = self:Clip1()
	mul = clip == 0 and 1 or 1 - self.IncAmmoPerc
	
	if clip == 0 then
		self.ShouldBolt = true
	end
	
	seqdur = vm:SequenceDuration()
	time = seqdur / self.ReloadSpeed * self.IncAmmoPerc
	CT = CurTime()
	
	self.ReloadTime = CT + time
	self:SetNextPrimaryFire(CT + (seqdur / self.ReloadSpeed) * mul)
	self:SetNextSecondaryFire(CT + (seqdur / self.ReloadSpeed) * mul)
	self.ReloadDelay = CT + (seqdur / self.ReloadSpeed + 0.3) * mul
	self.Owner.AttachDelay = CT + (seqdur / self.ReloadSpeed) * mul
	self.MeleeDelay = CT + (seqdur / self.ReloadSpeed) * mul
end

function SWEP:FinishCustomReload(bolt)
	CT = CurTime()
	clip = self:Clip1()
	ammo = self.Owner:GetAmmoCount(self.Primary.Ammo)
	//local AvailableReload = clamp(clip + self.Owner:GetAmmoCount(self.Primary.Ammo), 0, self.Primary.ClipSize)
	AmountToReload = clamp(self.Primary.ClipSize - clip, 0, self.Primary.ClipSize)
	
	if clip == 0 then
		self.Owner:RemoveAmmo(AmountToReload, self.Primary.Ammo)
		self:SetClip1(clamp(ammo, 0, self.Primary.ClipSize))
	else
		chamber = self.ChamberAmount or 1
		
		if ammo > (AmountToReload + chamber) and self.CantChamber != true then
			self.Owner:RemoveAmmo(AmountToReload + chamber, self.Primary.Ammo)
			self:SetClip1(clamp(self.Primary.ClipSize + chamber, 0, self.Primary.ClipSize + 1))
		else
			self.Owner:RemoveAmmo(AmountToReload + chamber, self.Primary.Ammo)
			self:SetClip1(clamp(ammo + clip, 0, self.Primary.ClipSize))
		end
		
		if self.SkipIdle != true then
			self:SendWeaponAnim(ACT_VM_IDLE)
			self:SetNextPrimaryFire(CT + 0.25)
			self:SetNextSecondaryFire(CT + 0.25)
			self.ReloadDelay = CT + 0.25
			self.Owner.AttachDelay = CT + 0.25
			self.MeleeDelay = CT + 0.25
		end
	end
	
	if bolt == false or self.NoBoltAnim == true then
		self.ShouldBolt = false
	else
		self:BoltWeaponry()
		self.ShouldBolt = false
	end
end

function SWEP:BoltWeaponry()
	self:SendWeaponAnim(ACT_VM_DRAW)
	self.Owner:GetViewModel():SetPlaybackRate(self.ReloadSpeed)
	
	tsim((vm:SequenceDuration() / self.ReloadSpeed) - 0.2, function()
		if self.Weapon == nil or self:GetClass() != self.Owner:GetActiveWeapon():GetClass() then
			return
		end
		
		self:SendWeaponAnim(ACT_VM_IDLE)
	end)
end

local sp
local td = {}

function SWEP:Think()	
	CT = CurTime()
	dtint3 = self:GetDTInt(3)
	wepclass = self:GetClass()
	
	if self.ReloadTime then
		if CT > self.ReloadTime then
			if self:Clip1() == 0 then
				self:FinishCustomReload(true)
			else
				self:FinishCustomReload(false)
			end
			
			self.ReloadTime = nil
		end
	end

	if SERVER then
		AimVec = self.Owner:GetAimVector()
		
		if not self.Owner.LastView then
			self.Owner.LastView = AimVec
			self.Owner.ViewAff = 0
		else
			self.Owner.ViewAff = Lerp(0.25, self.Owner.ViewAff, (AimVec - self.Owner.LastView):Length() * 0.15)
			self.Owner.LastView = AimVec
		end
		
		if self.Owner:Crouching() and self.Owner:OnGround() then
			self.ConeAff1 = 0.005
			self.ConeDecAff1 = 0.0025
			self.RecoilAff2 = 0.2
		else
			self.ConeAff1 = 0
			self.ConeDecAff1 = 0
			self.RecoilAff2 = 0
		end
		
		if self.dt.Sil then
			self.RecoilAff3 = 0.15
		else
			self.RecoilAff3 = 0
		end
		
		if dtint3 == 1 then
			self.ConeDecAff2 = 0.0045
			self.RecoilAff1 = 0.3
			self.CurCone = self.IronsightsCone / GetConVarNumber("cstm_accuracymod_aim")
			
			if (wepclass:find("^cstm_rif_") or wepclass:find("^cstm_sniper_")) and not self.Primary.Automatic then
				self.ConeAff3 = 0.003
			else
				self.ConeAff3 = 0
			end
		elseif dtint3 == 17 then
			self.ConeDecAff2 = 0.0045
			self.RecoilAff1 = 0.5
			self.CurCone = self.IronsightsCone / GetConVarNumber("cstm_accuracymod_aim")
		else
			self.ConeDecAff2 = 0
			self.RecoilAff1 = 0
			self.CurCone = self.HipCone / GetConVarNumber("cstm_accuracymod_hip")
			
			if wepclass:find("^cstm_rif_") or wepclass:find("^cstm_sniper_") then
				self.ConeAff3 = 0
			end
		end
		
		if self.InstalledBipod then
			can = false
			
			if self.Owner:GetVelocity():Length() == 0 then
				sp = self.Owner:GetShootPos()
				
				td.start = sp
				td.endpos = td.start + Vector(AimVec.x, AimVec.y, (AimVec.z * 0.5 - 1) * 0.8) * 25
				td.filter = self.Owner
				
				trace = util.TraceLine(td)
				
				if trace.Hit then -- make sure we have something to place the bipod on
					if not trace.Entity:IsPlayer() and not trace.Entity:IsNPC() then
						td.start = sp - Vector(0, 0, 10)
						td.endpos = td.start + AimVec * 30
						td.filter = self.Owner
						
						trace = util.TraceLine(td)
						
						if not trace.Hit then -- make sure the bipod is not gonna hit something below your crosshair
							td.start = sp 
							td.endpos = td.start + AimVec * 30
							td.filter = self.Owner
							
							trace = util.TraceLine(td)
							
							if not trace.Hit then -- make sure there is nothing ahead of the player
								if not trace.Entity:IsPlayer() and not trace.Entity:IsNPC() then
									if dtint3 != 1 then
										self.CurCone = self.IronsightsCone + 0.01
										self.RecoilAff1 = 0.6
									else
										self.RecoilAff1 = 0.7
									end
									
									can = true
								end
							end
						end
					end
				end
			end
			
			self:SetDTBool(1, can)
		end
	
		self.Primary.Cone = clamp((self.CurCone + self.ConeInaccuracy + ((self.Owner:GetVelocity():Length() / 10000) * (dtint3 == 1 and self.VelocitySensivity * 0.3 or self.VelocitySensivity)) - (self.ConeAff1 + self.ConeAff3) + self.Owner.ViewAff), 0.001, 0.15)
		self:SetDTFloat(0, clamp(self.Primary.Cone, 0.0001, 0.12 * (1 - (self.RecoilAff1 + self.RecoilAff2))))
		self:SetDTFloat(1, clamp(1 - self.RecoilAff1 - self.RecoilAff2 - self.RecoilAff3, 0.05, 1))
		
		if CT > self.ConeInaccDelay then
			self.ConeInaccuracy = clamp(self.ConeInaccuracy - 0.0015, 0, 0.08 * self.ConeInaccuracyAff1)
		end
	
		/*if self.Owner:KeyPressed(IN_USE) then
			if self:GetDTInt(3) != 17 then
				local aimVec = self.Owner:GetAimVector()
				local tracedata = {}
				tracedata.startpos = self.Owner:GetShootPos()
				tracedata.endpos = tracedata.startpos + Vector(aimVec.x * 30, aimVec.y * 30, -20)
				tracedata.filter = self.Owner
				
				local trace = util.TraceLine(tracedata)
				
				local tracedata2 = {}
				tracedata2.startpos = self.Owner:GetShootPos()
				tracedata2.endpos = tracedata2.startpos + Vector(aimVec.x * 30, aimVec.y * 30, 0)
				tracedata2.filter = self.Owner
				
				local trace2 = util.TraceLine(tracedata2)
				
				if trace.Hit and not trace2.Hit then
					self:SetDTInt(3, 17)
					self.ConeInaccuracyAff1 = self.ConeInaccuracyAff1 * 0.5
					self:EmitSound("weapons/awp/awp_clipout.wav", 80, 100)
				end
			elseif self:GetDTInt(3) == 17 then
				self:SetDTInt(3, 0)
				self.ConeInaccuracyAff1 = self.ConeInaccuracyAff1 / 0.5
			end
		end*/
		
		/*if self.Owner:KeyPressed(IN_USE) then
		
			if self:GetDTInt(3) >= 10 then
				self:SetDTInt(3, 0)
			else
				local trace1 = {}
				trace1.start = self.Owner:GetShootPos() + self.Owner:EyeAngles():Right() * 12
				trace1.endpos = trace1.start + self.Owner:EyeAngles():Forward() * 30
				trace1.filter = self
				
				local trRi = util.TraceLine(trace1)
				//print("trRi" .. trRi)
				
				local trace2 = {}
				trace2.start = self.Owner:GetShootPos() + self.Owner:EyeAngles():Right() * -12
				trace2.endpos = trace2.start + self.Owner:EyeAngles():Forward() * 30
				trace2.filter = self
				
				local trLe = util.TraceLine(trace2)
				//print("trLe" .. trLe)
				
				local trace3 = {}
				trace3.start = self.Owner:GetShootPos() + self.Owner:EyeAngles():Up() * 10
				trace3.endpos = trace3.start + self.Owner:EyeAngles():Forward() * 40
				trace3.filter = self
				
				local trUp = util.TraceLine(trace3)
				//print("trUp" .. trUp)
				
				//if not trRi.Hit and not trLe.Hit and not trUp.Hit then
				if trRi and trLe and trUp then
					if not trRi.Hit and (trLe.Hit or trUp.Hit) then

						self:SetDTInt(3, 10)
						
					elseif not trLe.Hit and (trRi.Hit or trUp.Hit) then
					
						self:SetDTInt(3, 11)
						
					elseif not trUp.Hit and trRi.Hit and trLe.Hit then
					
						self:SetDTInt(3, 12)
						
					end
				end
				
				print("right " .. tostring(trRi.Hit))
				print("left " .. tostring(trLe.Hit))
				print("up " .. tostring(trUp.Hit))
			end
		end*/
		
		if dtint3 == 1 then
			if not self.Owner:KeyDown(IN_ATTACK2) then
				if tonumber(self.Owner:GetInfo("cstm_hold_to_aim")) > 0 then
					self:SetDTInt(3, 0)
					self.Owner:SetFOV(0, 0.3)
					self.Owner:DrawViewModel(true)
				end
			end
		end
	end
	
	if not self.Owner:KeyDown(IN_ATTACK) and self.NumShots != 0 and self.Burst then
		self:SetNextPrimaryFire(CT + self.Primary.Delay * 2)
		self.NumShots = 0
	end

	if SERVER then
		if self.Owner:KeyDown(IN_SPEED) and self.Owner:OnGround() and dtint3 != 6 and dtint3 != 10 and dtint3 != 15 and dtint3 != 17 and dtint3 != 18 then 
			if self.Owner:GetVelocity():Length() > self.Owner:GetWalkSpeed() then
				if dtint3 != 2 and dtint3 != 15 and dtint3 != 18 then
					if wepclass:find("^cstm_pistol_") then
						self:SetDTInt(3, 18)
					else
						self:SetDTInt(3, 2)
					end
					
					if SERVER then
						self.Owner:SetFOV(0, 0.3)
						self.Owner:DrawViewModel(true)
					end
				end
				
			else
				if dtint3 != 1 or dtint3 != 8 and dtint3 != 10 and dtint3 != 11 and dtint3 != 12 and dtint3 != 15 and dtint3 != 17 and dtint3 != 18 then
					self:SetDTInt(3, 0)
					
					if SERVER then
						self.Owner:SetFOV(0, 0.3)
						self.Owner:DrawViewModel(true)
					end
				end
			end
		elseif not self.Owner:KeyDown(IN_SPEED) and dtint3 != 1 and dtint3 != 0 and dtint3 != 6 and dtint3 != 8 and dtint3 != 10 and dtint3 != 11 and dtint3 != 12 and dtint3 != 15 and dtint3 != 17 and dtint3 != 19 or not self.Owner:OnGround() and dtint3 != 6 and dtint3 != 0 and dtint3 != 15 and dtint3 != 17 then
			self:SetDTInt(3, 0)
			
			if SERVER then
				self.Owner:SetFOV(0, 0.2)
				self.Owner:DrawViewModel(true)
			end
		end
	end
	
	dtint3 = self:GetDTInt(3) -- get it again because it was most likely updated
	
	if dtint3 == 1 then
		tr = self.Owner:GetEyeTrace()
		
		if tr.HitPos:Distance(self.Owner:GetShootPos()) <= 30 then
			self:SetDTInt(3, 0)
			self.Owner:SetFOV(0, 0.2)
			self:SetNextPrimaryFire(CT + 0.2)
			self:SetNextSecondaryFire(CT + 0.2)
		end
	end
		
	if not self.Owner:KeyDown(IN_RELOAD) then
		if self.HasReleasedKey == false then
			self.HasReleasedKey = true
		end
	end
	
	if self.Burst and not self.Owner:KeyDown(IN_ATTACK) then
		self.Shots = 0
	end
	
	if CLIENT then
		if self:GetDTBool(1) then
			if not self.BipodActive then
				self.BipodActive = true
				surface.PlaySound("weapons/cstm/attach.wav")
			end
		else
			if self.BipodActive then
				self.BipodActive = false
				surface.PlaySound("weapons/cstm/detach.wav")
			end
		end
		
		self.Owner:GetViewModel().BuildBonePositions = function(self, numbon, numphysbon)
			ply = LocalPlayer()
			wep = ply:GetActiveWeapon()
			
			if not ValidEntity(wep) then
				return
			end
			
			vm = ply:GetViewModel()
			activity = wep:GetSequenceActivityName(wep:GetSequence())
			seqdur = vm:SequenceDuration()
			FT = FrameTime()
			
			if not wep.IsCustomWeapon then
				return
			end
			
			if wep.MagBone then
				if wep.VElements and wep:IsActiveCModel("cmag") then 
					bone = vm:LookupBone(wep.MagBone)
					matrix = vm:GetBoneMatrix(bone)
							
					if matrix then
						matrix:Scale(Vector(0.01, 0.01, 0.01))
						vm:SetBoneMatrix(bone, matrix)
					end
				end
			end
				
			if wep.OtherBone then
				if wep.VElements and (wep:IsActiveCModel("eotech") or wep:IsActiveCModel("aimpoint") or wep:IsActiveCModel("acog")) then //((wep.VElements["eotech"] and wep.VElements["eotech"].color.a == 255) or (wep.VElements["aimpoint"] and wep.VElements["aimpoint"].color.a == 255) or (wep.VElements["acog"] and wep.VElements["acog"].color.a == 255)) then
					bone = vm:LookupBone(wep.OtherBone)
					matrix = vm:GetBoneMatrix(bone)
							
					if matrix then
						matrix:Scale(Vector(0.001, 0.001, 0.001))
						vm:SetBoneMatrix(bone, matrix)
					end
				end
			end

			if self.ViewModelBonescales then
				for k, v in pairs( self.ViewModelBonescales ) do
					bone = s:LookupBone(k)
					
					if (!bone) then 
						continue 
					end
					
					m = s:GetBoneMatrix(bone)
					
					if (!m) then 
						continue
					end
					
					m:Scale(v)
					s:SetBoneMatrix(bone, m)
				end
			end
			
			if wep:GetDTInt(3) == 15 then
				if wep.MeleeOffset then
					wep.TargetOffset = wep.MeleeOffset
				else
					if wep.VElements then
						if wep:IsActiveCModel("cmag") then
							wep.TargetOffset = wep.CMag_Idle
						elseif wep:IsActiveCModel("vertgrip") then
							wep.TargetOffset = wep.VertGrip_Idle
						end
					end
				end
			else
				if wep.VElements then
					if wep.OffsetMeStage == 1 then
						wep.TargetOffset = "none"
					elseif wep.OffsetMeStage == 2 then
						wep.TargetOffset = "none"
						
						if wep:IsActiveCModel("grenadelauncher") then
							if wep:GetDTInt(3) == 8 then
								wep.TargetOffset = wep.GrenadeLauncher_Active
							else
								wep.TargetOffset = wep.GrenadeLauncher_Idle
							end
						elseif wep:IsActiveCModel("vertgrip") then
							wep.TargetOffset = wep.VertGrip_Idle
						end
						
						if wep:IsActiveCModel("cmag") then
							if activity == "ACT_VM_RELOAD" or activity == "ACT_VM_RELOAD_SILENCED" then
								wep.TargetOffset = wep.CMag_Reload or "none"
							else
								if wep.TargetOffset == "none" then
									wep.TargetOffset = wep.CMag_Idle or "none"
								end
							end
						end
					end
				else
					wep.TargetOffset = "none"
				end
			end
		
			if wep.TargetOffset == "none" and wep.OffsetBones then
				for k, v in pairs(wep.OffsetBones) do
					wep.OffsetBones[k] = wep.OffsetBones[k] or {}
				
					if v.curoffset then	
						v.curoffset = LerpVector(FT * 27, v.curoffset, Vector(0, 0, 0))
					end
					
					if v.currotation then
						v.currotation = LerpVector(FT * 27, v.currotation, Vector(0, 0, 0))
					end
				
					bone = vm:LookupBone(k)
					matrix = self:GetBoneMatrix(bone)
							
					if matrix then
						if v.curoffset then
							matrix:Translate(wep.OffsetBones[k].curoffset)
						end
						
						if v.currotation then
							matrix:Rotate(wep.OffsetBones[k].currotation)
						end
						
						self:SetBoneMatrix(bone, matrix)
					end
				end
			else
				if wep.TargetOffset and wep.TargetOffset != "none" then
					for k, v in pairs(wep.TargetOffset) do
						
						wep.OffsetBones[k] = wep.OffsetBones[k] or {}
					
						if not wep.OffsetBones[k].curoffset and not wep.OffsetBones[k].currotation then
							wep.OffsetBones[k].curoffset = Vector(0, 0, 0)
							wep.OffsetBones[k].currotation = Vector(0, 0, 0)
						end
						
						if wep.OffsetMeStage == 1 then
							wep.OffsetBones[k].curoffset = LerpVector(FT * 27, wep.OffsetBones[k].curoffset, v.vector or Vector(0, 0, 0))
							wep.OffsetBones[k].currotation = LerpVector(FT * 27, wep.OffsetBones[k].currotation, v.angle or Vector(0, 0, 0))
						elseif wep.OffsetMeStage == 2 then
							wep.OffsetBones[k].curoffset = LerpVector(FT * 27, wep.OffsetBones[k].curoffset, v.vector)
							wep.OffsetBones[k].currotation = LerpVector(FT * 27, wep.OffsetBones[k].currotation, v.angle)
						end
						
						bone = vm:LookupBone(k)
						matrix = self:GetBoneMatrix(bone)
						
						if matrix then
							matrix:Translate(wep.OffsetBones[k].curoffset)
							matrix:Rotate(wep.OffsetBones[k].currotation)
							self:SetBoneMatrix(bone, matrix)
						end
					end
				end
			end
				
			if (activity == "ACT_VM_RELOAD" or activity == "ACT_VM_RELOAD_SILENCED" or activity == "ACT_VM_ATTACH_SILENCER" or activity == "ACT_VM_DETACH_SILENCER") or (activity == "ACT_VM_DRAW" and wep.NoMoveOnDraw) and not wep:GetClass():find("^cstm_shotgun") then
				if not wep.TimerCreated then
					wep.OffsetMeStage = 1
					
					TimeRel, TimeIdle = nil, nil
					
					if wep:Clip1() > 0 and (activity == "ACT_VM_RELOAD" or activity == "ACT_VM_RELOAD_SILENCED") then
						TimeRel = (seqdur * wep.IncAmmoPerc) / wep.ReloadSpeed
						TimeIdle = (seqdur * wep.IncAmmoPerc) / wep.ReloadSpeed
					else
						TimeRel = (seqdur / wep.ReloadSpeed) - 0.5
						TimeIdle = (seqdur / wep.ReloadSpeed) - 0.01
					end
					
					tsim(TimeRel, function()
						wep.OffsetMeStage = 2
					end)
				
					if wep:Clip1() != 0 then
						if not wep.SkipIdle then
							tsim(TimeIdle, function()
								wep:SendWeaponAnim(ACT_VM_IDLE)
							end)
						end
					end
						
					wep.TimerCreated = true
				end
			else
				wep.TimerCreated = false
				wep.OffsetMeStage = 2
			end
		end
	end
end

local rec

function SWEP:PrimaryAttack()
	if self.ReloadTime then
		return
	end
	
	tr = self.Owner:GetEyeTrace()
	
	if tr.HitPos:Distance(self.Owner:GetShootPos()) < 30 then
		return
	end
	
	dtint3 = self:GetDTInt(3)
	
	if dtint3 == 2 or dtint3 == 19 then
		return
	end
	
	CT = CurTime()
	
	if self.SecondaryAtt == 1 and self.Owner:KeyDown(IN_USE) and dtint3 != 8 then
		if SERVER then
			if self.Grenade == false then
				self.Owner:EmitSound("weapons/shotgun/shotgun_empty.wav", 65, rand(99, 101))
				self.Grenade = true
			else
				self.Owner:EmitSound("weapons/ClipEmpty_Rifle.wav", 65, rand(99, 101))
				self.Grenade = false
			end
		end
		
		self:SetNextPrimaryFire( CT + 0.25 )
		self:SetNextSecondaryFire( CT + 0.25 )
		return
	end
	
	clip = self:Clip1()
	
	if (clip == 0 or self.Owner:WaterLevel() == 3) and not self.Grenade then
		self:EmitSound("weapons/shotgun/shotgun_empty.wav", 65, rand(99, 101))
		self:SetNextSecondaryFire( CT + 0.05 )
		self:SetNextPrimaryFire( CT + 0.25 )
		return
	end
	
	if CLIENT and not SinglePlayer() then
		if self.Owner:KeyDown(IN_USE) then
			if (self.VElements and self.VElements["grenadelauncher"] and self.VElements["grenadelauncher"].color.a == 255) or dtint3 == 8 then
				return
			end
		else
			if self.VElements and self.VElements["grenadelauncher"] and self.VElements["grenadelauncher"].color.a == 255 and dtint3 == 8 then
				return
			end
		end
	end
	
	if SERVER then
		if self.SecondaryAtt == 1 and self.Grenade and dtint3 == 8 then
			if self.Owner:GetAmmoCount("SMG1_Grenade") == 0 then
				self.Owner:EmitSound("weapons/shotgun/shotgun_empty.wav", 65, rand(99, 101))
				self:SetNextPrimaryFire( CT + 0.25 )
				self:SetNextSecondaryFire( CT + 0.05 )
				return
			end
		
			local prop = ents.Create(self.GrenadeType)
			prop:SetPos(self.Owner:EyePos() + self.Owner:GetAimVector() * 24 + self.Owner:GetRight() * 4 + self.Owner:GetUp() * -6)
			prop:SetOwner(self.Owner)
			prop:SetAngles(self.Owner:EyeAngles())
			prop.BlastRadius = self.BlastRadius
			prop.BlastDamage = self.BlastDamage
			prop:Spawn()
			prop:GetPhysicsObject():SetVelocity(self.Owner:GetAimVector() * 3500)
			prop:SetGravity(1.4)
			prop:SetOwner(self.Owner)
			
			self.Owner:ViewPunch(Angle(-10, 0, 0))
			self.Owner:EmitSound("weapons/grenade_launcher1.wav", 85, 100)
			self:TakeSecondaryAmmo(1)
			self:SetDTInt(3, 0)
			self.Owner:SetFOV(0, 0.3)
			
			if self.Owner:GetAmmoCount("SMG1_Grenade") > 0 then
				self:SetNextPrimaryFire(CT + 3)
				self:SetNextSecondaryFire(CT + 3)
				self.ReloadDelay = CT + 3
				self.Owner.AttachDelay = CT + 3
			else
				self:SetNextPrimaryFire(CT + 0.3)
				self:SetNextSecondaryFire(CT + 0.3)
				self.ReloadDelay = CT + 0.3
				self.Owner.AttachDelay = CT + 0.3
			end
			
			tsim(0.5, function()
				if (self.Weapon == nil or self:GetClass() != self.Owner:GetActiveWeapon():GetClass()) or self.Owner:GetAmmoCount("SMG1_Grenade") == 0 then
					return
				end
			
				self:SetDTInt(3, 6)
			end)
				
			tsim(1, function()
				if (self.Weapon == nil or self:GetClass() != self.Owner:GetActiveWeapon():GetClass()) or self.Owner:GetAmmoCount("SMG1_Grenade") == 0 then
					return
				end
				
				self.Owner:EmitSound("weapons/smg1/smg1_reload.wav", 50, 100)
				self.Owner:DoAnimationEvent(ACT_ITEM_GIVE)
			end)
			
			tsim(2.75, function()
				if (self.Weapon == nil or self:GetClass() != self.Owner:GetActiveWeapon():GetClass()) or self.Owner:GetAmmoCount("SMG1_Grenade") == 0 then
					return
				end
				
				self:SetDTInt(3, 0)
			end)
				
			if self.Owner:GetAmmoCount("SMG1_Grenade") == 0 then
				self.Grenade = false
			end
			
			return
		end
	end
	
	self:SetNextSecondaryFire( CT + self.Primary.Delay )
	self:SetNextPrimaryFire( CT + self.Primary.Delay )
	
	if ( !self:CanPrimaryAttack() ) then return end
	
	self:TakePrimaryAmmo( 1 )
	
	if SERVER then
		if not self.dt.Sil then
			self.Owner:EmitSound(self.Primary.Sound, self.UnsilencedVolume, rand(99, 101))
		else
			self.Owner:EmitSound(self.SilencedSound, self.SilencedVolume, rand(99, 101))
		end
	end
		
	if clip <= 10 then
		self.Owner:EmitSound("weapons/ClipEmpty_Rifle.wav", 60 - (clip * 4), 100)
	end
	
	if SERVER then
		if not SinglePlayer() then
			ef = EffectData()
			ef:SetOrigin(self.Owner:GetShootPos())
			ef:SetEntity(self.Weapon)
			ef:SetAngle(self.Owner:GetAngles())
			util.Effect("ef_muzzle", ef)
		end
	end
	
	self.ReloadDelay = CT + 0.5
	self.Owner.AttachDelay = CT + 0.5
	self.MeleeDelay = CT + 0.3
	
	RecMod = GetGlobalFloat("CR")
	rec = self:GetDTFloat(1)

	if dtint3 != 1 then
		self:CSShootBullet( self.Primary.Damage, self.Primary.Recoil * 1.2 * RecMod, self.Primary.NumShots, self:GetDTFloat(0))
		self:Recoil(self.Primary.Recoil * 1.2 * rec * RecMod)
	else
		self:CSShootBullet( self.Primary.Damage, self.Primary.Recoil * 0.75 * RecMod, self.Primary.NumShots, self:GetDTFloat(0))
		self:Recoil(self.Primary.Recoil * 0.75 * rec * RecMod)
	end
	
	if CLIENT then
		if dtint3 == 1 then
			self.RecoilAmt = 1.5
			self:MuzzleFlosh()
		end
	end
	
	if SERVER and SinglePlayer() then
		if dtint3 == 1 then
			SendUserMessage("RECOIL", self.Owner)
		end
	end
	
	self.Owner:ViewPunch(Angle(-1 * (self.Primary.Recoil + self.ConeInaccuracy * 4) * rec, 0, 0 ) * RecMod)
	
	self.ConeInaccuracy = clamp(self.ConeInaccuracy + (0.005 + self.DefRecoil * (0.006 - (self.ConeDecAff1 + self.ConeDecAff2))) * self.InaccAff1, 0, 0.12 * (self.ConeInaccuracyAff1))
	self.ConeInaccDelay = CT + self.Primary.Delay * 1.05
	
	if ( self.Owner:IsNPC() ) then return end
end

local damagemod1, damagemod2

/*---------------------------------------------------------
   Name: SWEP:CSShootBullet( )
---------------------------------------------------------*/
function SWEP:CSShootBullet( dmg, recoil, numbul, cone )
	numbul 	= numbul 	or 1
	cone 	= cone 		or 0.01
		
	/*local offset
	
	if self:GetDTInt(3) == 10 then
		offset = self.Owner:EyeAngles():Right() * 10
	elseif self:GetDTInt(3) == 11 then
		offset = self.Owner:EyeAngles():Right() * -10
	elseif self:GetDTInt(3) == 12 then
		offset = self.Owner:EyeAngles():Up() * 10
	else
		offset = Vector(0, 0, 0)
	end*/
		
	if self.dt.Sil then
		damagemod1 = 0.1
	else
		damagemod1 = 0
	end
	
	if self:GetDTInt(2) == 1 then
		damagemod2 = 0.3
	else
		damagemod2 = 0
	end
	
	if SinglePlayer() then
		if SERVER then
			for i = 1, self.Primary.NumShots do
				self.Owner:FireBulletsEx(1, self.Owner:GetShootPos(), (self.Owner:EyeAngles() + self.Owner:GetPunchAngle()):Forward(), self.Primary.Damage * (1 - (damagemod1 + damagemod2)), self:GetDTFloat(0), 10)
			end
		end
	else
		bullet = {}
		bullet.Num 		= numbul
		bullet.Src 		= self.Owner:GetShootPos()			// Source
		bullet.Dir 		= ( self.Owner:EyeAngles() + self.Owner:GetPunchAngle() ):Forward()		// Dir of bullet
		bullet.Spread 	= Vector( cone, cone, 0 )			// Aim Cone
		bullet.Tracer	= 4									// Show a tracer on every x bullets 
		bullet.Force	= self.Primary.Damage		// Amount of force to give to phys objects
		bullet.Damage = math.Round(self.Primary.Damage * (1 - (damagemod1 + damagemod2 )))
		
		bullet.Callback = function(attacker, trace, dmginfo)
			if SERVER and self:GetDTInt(2) == 1 then
				if ValidEntity(trace.Entity) then
					trace.Entity:Ignite(6)
				end
			end
			
			ParticleEffect("cstm_incendiary_hit", trace.HitPos, trace.HitNormal:Angle(), nil)
			--[[local penetrationForce
			local hitMat = trace.MatType 
			
			if hitMat == MAT_PLASTIC then
				penetrationForce = 1.25
			elseif hitMat == MAT_WOOD then
				penetrationForce = 1
			elseif hitMat == MAT_TILE then
				penetrationForce = 0.75
			elseif hitMat == MAT_CONCRETE then
				penetrationForce = 0.5
			elseif hitMat == MAT_METAL or hitMat == MAT_VENT then
				penetrationForce = 0.5
			else
				penetrationForce = 1
			end
			
			local forward = bullet.Dir:Normalize()
			local tr = {}
			tr.start = trace.HitPos
			tr.endpos = tr.start
			tr.filter = self
			
			local trace2 = util.TraceLine(tr)
			
			if not trace2.HitWorld and trace.Entity != trace2.Entity then
				local bullet2 = {}
				bullet2.Num = bullet.Num
				bullet2.Src = trace.HitPos + forward * 8 * penetrationForce
				bullet2.Dir = bullet.Dir
				bullet2.Spread = Vector(0, 0, 0)
				bullet2.Tracer = bullet.Tracer
				bullet2.Force = bullet.Force * 0.5
				bullet2.Damage = bullet.Damage * 0.5
				//ParticleEffect("cstm_penetration_smoke", trace.HitPos + (forward * 4) * penetrationForce, Angle(0, 0, 0), nil)

				if SERVER then
					self.Owner:LagCompensation(false)
				end
				
				self.Owner:FireBullets(bullet2)
			end]]--
			
		end
		
		self.Owner:FireBullets(bullet)
	end
	
	vm = self.Owner:GetViewModel()
	
	if self:GetDTInt(3) != 1 then
		self:SendWeaponAnim(ACT_VM_PRIMARYATTACK) 		// View model animation
		self.AnimPlayed = true
		
		vm:SetPlaybackRate(self.PlaybackRate or 1)
	else
		if self:GetClass():find("cstm_sniper_") then
			self:SendWeaponAnim(ACT_VM_PRIMARYATTACK)
		else
			if not self.AnimPlayed or self.PlayFireAnim then
				self:SendWeaponAnim(ACT_VM_PRIMARYATTACK)
				vm:SetPlaybackRate(self.PlaybackRate or 1)
				
				if not self.PlayFireAnim then
					vm:SetPlaybackRate(10)
				end
				
				self.AnimPlayed = true
			end
		end
	end
	
	if not self.dt.Sil then
		self.Owner:MuzzleFlash()								// Crappy muzzle light
	end
	
	self.Owner:SetAnimation(PLAYER_ATTACK1)				// 3rd Person Animation
	
	if ( self.Owner:IsNPC() ) then return end
	
	// CUSTOM RECOIL !
end

function SWEP:Recoil(recoil)
	if ((SinglePlayer() && SERVER) || (!SinglePlayer() && CLIENT && IsFirstTimePredicted())) then
		eyeang = self.Owner:EyeAngles()
		eyeang.pitch = eyeang.pitch - (recoil * 0.5)
		eyeang.yaw = eyeang.yaw - (recoil * rand(-1, 1) * 0.25)
		self.Owner:SetEyeAngles(eyeang)
	end
end


/*---------------------------------------------------------
	Checks the objects before any action is taken
	This is to make sure that the entities haven't been removed
---------------------------------------------------------*/

local CurMul1 = 0
local CurMul2 = 0
local CurMul3 = 0
local CurMove = -2
local AmntToMove = 0.4
local MoveCycle = 0
local Ironsights_Time = 0.1
local CurShakeA = 0.03
local CurShakeB = 0.03
local randomdir = 0
local randomdir2 = 0
local timetorandom = 0
local BlendPos = Vector(0, 0, 0)
local BlendAng = Vector(0, 0, 0)
local ApproachRate = 0.2
local Off3, dist
local Off4 = 0

function SWEP:GetViewModelPosition(pos, ang)
	CT = CurTime()
	
	if self.UseGoggle then
		if CT > self.TimeToUseGoggle then -- this is when the player is aiming through the scope of a sniper rifle and the scope overlay texture is displayed
			return pos - ang:Forward() * 50, ang
		end
	end
	
	FT = FrameTime()
	dtint3 = self:GetDTInt(3)
	
	if dtint3 == 2 then
		if self.ViewModelFlip then
			TargetPos = Vector(-0.82, -0.165, 0.656)
			TargetAng = Vector(-9.754, -24.673, 0)
		else
			TargetPos = Vector(-0.82, 0.165, 0.656)
			TargetAng = Vector(-9.754, 24.673, 0)
		end
		
		/*if self:GetClass():find("^cstm_pistol_") then
			TargetPos = self.RunPosPistol
			TargetAng = self.RunAngPistol
		else
			if self.ViewModelFlip == true then
				TargetPos = self.RunPos
				TargetAng = self.RunAng
			else
				TargetPos = self.RunPosNoFlip
				TargetAng = self.RunAngNoFlip
			end
		end*/
	elseif dtint3 == 1 then
		TargetPos = self.AimPos
		TargetAng = self.AimAng
	elseif dtint3 == 6 then
		TargetPos = Vector(0, -0.82, -5)
		
		if self.ViewModelFlip then
			TargetAng = Vector(-25.247, -47.049, 0)
		else
			TargetAng = Vector(-25.247, 47.049, 0)
		end
	elseif dtint3 == 15 then
		if self.ViewModelFlip then
			TargetPos = self.MeleePos or Vector(0, 0, 0)
			TargetAng = self.MeleeAng or Vector(0, 0, 0)
		else
			TargetPos = self.MeleePosNoFlip or Vector(0, 0, 0)
			TargetAng = self.MeleeAngNoFlip or Vector(0, 0, 0)
		end
	elseif dtint3 == 19 then
		if self.ViewModelFlip then
			TargetPos = self.CustomizePos or Vector(-6.244, -1.658, -0.82)
			TargetAng = self.CustomizeAng or Vector(31.43, -35.975, -29.837)
		else
			TargetPos = self.CustomizePos or Vector(7.211, -6.475, 0.093)
			TargetAng = self.CustomizeAng or Vector(30.736, 40.668, 28.569)
		end
	/*elseif self:GetDTInt(3) == 10 then
		if self.ViewModelFlip then
			TargetPos = Vector(-10, 0, 0)
		else
			TargetPos = Vector(10, 0, 0)
		end
		TargetAng = Vector(0, 0, 0)
	elseif self:GetDTInt(3) == 11 then
		if self.ViewModelFlip then
			TargetPos = Vector(15, 0, 0)
		else
			TargetPos = Vector(-15, 0, 0)
		end
		TargetAng = Vector(0, 0, 0)
	elseif self:GetDTInt(3) == 12 then
		TargetPos = Vector(-0.987, -10.082, 7.313)
		TargetAng = Vector(0, 0, 0)*/
	else
		if GetConVarNumber("cstm_different_origins") > 0 then
			if self.ViewModelFlip == true then
				TargetPos = self.FlipOriginsPos
				TargetAng = self.FlipOriginsAng
			else
				TargetPos = self.NoFlipOriginsPos
				TargetAng = self.NoFlipOriginsAng
			end
		else
			TargetPos = Vector(0, 0, 0)
			TargetAng = Vector(0, 0, 0)
		end
	end
	
	if dtint3 == 1 then
		ApproachRate = FT * 20 
	elseif dtint3 == 6 or dtint3 == 7 then
		ApproachRate = FT * 4
	elseif dtint3 == 15 then
		ApproachRate = FT * 40
	else
		ApproachRate = FT * 7
	end
	
	BlendPos = LerpVector(ApproachRate, BlendPos, TargetPos)
	BlendAng = LerpVector(ApproachRate, BlendAng, TargetAng)
		
	CurShakeA = app(CurShakeA, randomdir, 0.01)
	CurShakeB = app(CurShakeB, randomdir2, 0.01)
		
	if CT > timetorandom then
		randomdir = rand2(-0.1, 0.1)
		randomdir2 = rand2(-0.1, 0.1)
		timetorandom = CT + 0.2
	end
	
	if dtint3 == 1 then 
		self.SwayScale 	= 0
		self.BobScale 	= 0.35
	elseif dtint3 == 2 or dtint3 == 4 then
		self.SwayScale 	= 0
		self.BobScale 	= 0
	elseif dtint3 == 0 then
		self.SwayScale 	= 0
		self.BobScale 	= 1
	end

	if CurMove == -2 then
		MoveCycle = 1
	elseif CurMove == 2 then
		MoveCycle = 2
	end
	
	if MoveCycle == 1 then
		CurMove = app(CurMove, 2, 0.11 - CurMove * 0.05)
	elseif MoveCycle == 2 then
		CurMove = app(CurMove, -2, 0.11 - CurMove * 0.05)
	end
	
	RS = clamp(self.Owner:GetRunSpeed() / 100, 0, 5)
	
	if dtint3 == 2 then
		Off = sin(CT * (7 + RS))
		Off2 = cos(CT * (7 + RS))
		Off3 = math.atan(Off, Off2)
	else
		Off = 0
		Off2 = 0
		Off3 = 0
	end
	
	if dtint3 != 19 and dtint3 != 15 then
		tr = self.Owner:GetEyeTrace()
		dist = tr.HitPos:Distance(self.Owner:GetShootPos())
		
		if dist <= 30 then
			Off4 = Lerp(FT * 15, Off4, 30 - dist)
		else
			Off4 = Lerp(FT * 15, Off4, 0)
		end
	else
		Off4 = Lerp(FT * 15, Off4, 0)
	end

	if self.ViewModelFlip then
		ang = ang * 1
		ang:RotateAroundAxis( ang:Right(), 		(Off3 - Off2) * 3 + BlendAng.x + self.AngleDelta.p * 0.3 + Off4 * 3 + CurShakeB * self.BobScale)
		ang:RotateAroundAxis( ang:Up(), 		(Off - Off2) * 10 + BlendAng.y - self.AngleDelta.y * 0.4 + CurShakeA * self.BobScale)
		ang:RotateAroundAxis( ang:Forward(), 	(Off3 + (Off2 - Off)) * 5 + BlendAng.z + self.AngleDelta.y * 0.3 + CurShakeA * self.BobScale)
		
		Right 	= ang:Right()
		Up 		= ang:Up()
		Forward 	= ang:Forward()	
		
		pos = pos + (BlendPos.x - self.AngleDelta.y * 0.05 - Off4 * 0.25) * Right 
		pos = pos + (BlendPos.y + self.AngleDelta.p * 0.05 - Off - self.RecoilAmt - Off4 * 0.6) * Forward
		pos = pos + (BlendPos.z + (Off * Off2) * 0.5 - Off4 * 0.8) * Up
	else
		ang = ang * 1
		ang:RotateAroundAxis( ang:Right(), 		(Off3 - Off) * 3 + BlendAng.x + self.AngleDelta.p * 0.3 + Off4 * 3 + CurShakeB * self.BobScale)
		ang:RotateAroundAxis( ang:Up(), 		(Off - Off2) * 10 + BlendAng.y + self.AngleDelta.y * 0.4 + CurShakeA * self.BobScale)
		ang:RotateAroundAxis( ang:Forward(), 	(Off3 + (Off2 - Off)) * 5 + BlendAng.z + self.AngleDelta.y * 0.3 + CurShakeA * self.BobScale)
		
		Right 	= ang:Right()
		Up 		= ang:Up()
		Forward 	= ang:Forward()	
		
		pos = pos + (BlendPos.x + self.AngleDelta.y * 0.05 + Off4 * 0.25) * Right 
		pos = pos + ((BlendPos.y + self.AngleDelta.p * 0.05 + Off - self.RecoilAmt - Off4 * 0.6) * Forward)
		pos = pos + (BlendPos.z + (Off * Off2) * 0.5 - Off4 * 0.8) * Up
	end
	
	self.RecoilAmt = Lerp(FT * 10, self.RecoilAmt, 0)

	return pos, ang
end

SWEP.NextSecondaryAttack = 0

if SERVER then
	AttSoundDelay = 0

	function SWEP:NWAlpha(alpha)
		umsg.Start("NWAlpha")
			umsg.Entity(self)
			umsg.Short(alpha)
		umsg.End()
	end
	
	local can, att
	
	function RequestPimp(ply)
		wep = ply:GetActiveWeapon()
		
		if not wep.Attachments or #wep.Attachments == 0 then
			return
		end
		
		CT = CurTime()
		
		if CT < wep.ReloadDelay then
			return
		end
		
		if ValidEntity(wep) then
			dtint3 = wep:GetDTInt(3)
			
			if dtint3 == 0 then
				wep:SetDTInt(3, 19)
			elseif dtint3 == 19 then
				wep:SetDTInt(3, 0)
			end
			
			wep.ReloadDelay = CT + 0.1
			wep:SetNextPrimaryFire(CT + 0.2)
			wep:SetNextSecondaryFire(CT + 0.2)
		end
	end
	
	concommand.Add("cstm_requestpimp", RequestPimp)
	
	function AskAttachments(ply)
		wep = ply:GetActiveWeapon()
		
		if not ValidEntity(wep) then
			return
		end
		
		if not wep.Attachments or #wep.Attachments == 0 then
			return
		end
		
		wep:SendAllAttachments()
	end
	
	concommand.Add("cstm_askatt", AskAttachments)
	
	function PimpMyGun(ply, com, args)
		att = args[1]
		
		if not att then
			return
		end
		
		att = tonumber(att)
		wep = ply:GetActiveWeapon()
		CT = CurTime()
		
		if CT < wep.ReloadDelay then
			return
		end
		
		if att == 2 or att == 3 or att == 4 or att == 9 then
			wep:NWATT2(att, true)
		else
			wep:NWATT2(att, false)
		end
	end
	
	concommand.Add("cstm_pimpmygun", PimpMyGun)
	
	function UnPimpMyGun(ply, com, args)
		att = args[1]
		
		if not att then
			return
		end
		
		att = tonumber(att)
		wep = ply:GetActiveWeapon()
		CT = CurTime()
		
		if CT < wep.ReloadDelay then
			return
		end
		
		if att == 2 or att == 3 or att == 4 or att == 9 then
			wep:Deselect(att, true)
		else
			wep:Deselect(att, false)
		end
	end
	
	concommand.Add("cstm_unpimpmygun", UnPimpMyGun)
	
	function SWEP:IsLastAtt(num, b)
		for k, v in pairs(self.Attachments) do
			for k2, v2 in pairs(v) do
				if AttEnum[v2] == number then
					if b then
						return v
					end
					
					return true
				end
			end
		end
	end
	
	function SWEP:NWATT2(number, scope)
		if self:GetDTInt(3) != 19 then
			return
		end
		
		for k, v in pairs(AttEnum) do
			if v == number then
				if not table.HasValue(self.Owner.Attachments, k) then
					return
				end
			end
		end
		
		CT = CurTime()
		
		if CT < self.ReloadDelay then
			return
		end
		
		self.Owner:SetFOV(0, 0.3)
		self.Owner:DrawViewModel(true)
		can = false
	
		if self.Weapon == nil then
			return
		end
		
		if number == 11 then
			if not self.NoBipod then
				if self.InstalledGrip then
					self.VelocitySensivity = self.VelocitySensivity / 0.65
					self.DefRecoil = self.DefRecoil / 0.8
					self.Primary.Recoil = self.DefRecoil
					self.ConeInaccuracyAff1 = self.ConeInaccuracyAff1 / 0.5
					self.InstalledGrip = false
				end
				
				self.SecondaryAtt = 0
				self.InstalledBipod = true
				can = true
			end
		elseif number == 10 then
			if not self.NoLaser then
				if not self.InstalledLaser then
					self.HipCone = self.HipCone * 0.85
					self.VelocitySensivity = self.VelocitySensivity * 0.75
					self.InaccAff1 = self.InaccAff1 * 0.85
					self.InstalledLaser = true
					can = true
				end
			end
		elseif number == 8 then
			if not self.NoCMag then
				if not self.CMagInstalled then
					clip = self:Clip1()
					ammo = self.Owner:GetAmmoCount(self.Primary.Ammo)
					
					self:SetClip1(0)
					self.Owner:SetAmmo(ammo + clip, self:GetPrimaryAmmoType())
					self.Primary.ClipSize = 100
					self.ReloadSpeed = 0.8
					self.CMagInstalled = true
					can = true
				
					umsg.Start("NWSPD")
						umsg.Entity(self)
						umsg.Float(0.8)
					umsg.End()
				end
			end
		elseif number == 7 then
			if not self.NoVertGrip then 
				if not self.InstalledGrip then
					self.VelocitySensivity = self.VelocitySensivity * 0.65
					self.DefRecoil = self.DefRecoil * 0.8
					self.Primary.Recoil = self.DefRecoil
					self.InstalledGrip = true
					self.ConeInaccuracyAff1 = self.ConeInaccuracyAff1 * 0.5
					self.SecondaryAtt = 0
					self.InstalledBipod = false
					self:SetDTBool(1, false)
					can = true
				end
			end
		elseif number == 6 then
			if not self.NoGL then
				if self.SecondaryAtt == 0 then
					if self.InstalledGrip then
						self.VelocitySensivity = self.VelocitySensivity / 0.65
						self.DefRecoil = self.DefRecoil / 0.8
						self.Primary.Recoil = self.DefRecoil
						self.ConeInaccuracyAff1 = self.ConeInaccuracyAff1 / 0.5
					end
					
					self.InstalledBipod = false
					self:SetDTBool(1, false)
					self.InstalledGrip = false
					self.SecondaryAtt = 1
					can = true
				end
			end
		end
			
		if scope then 
			self.ScopeStatus = number
			can = true
		end
			
		if can then
			for k, v in pairs(self.Attachments) do
				for k2, v2 in pairs(v) do
					if AttEnum[v2] == number then
						v.last = number
						break
					end
				end
			end
			
			self.ReloadDelay = CT + 0.15
			self.LastAttachment = number
			
			umsg.Start("NWATT2")
				umsg.Entity(self)
				umsg.Short(number)
			umsg.End()
		end
	end
	
	function SWEP:NetworkHoldType(ht)
		self:SetWeaponHoldType(ht)
		
		umsg.Start("NWHT")
			umsg.Entity(self)
			umsg.String(ht)
		umsg.End()
	end
	
	function SWEP:Deselect(num)
		if self:GetDTInt(3) != 19 then
			return
		end
		
		CT = CurTime()
		
		if CT < self.ReloadDelay then
			return
		end
		
		can = false
		
		if num == 2 or num == 3 or num == 4 or num == 9 then
			if self.ScopeStatus == num then
				self.ScopeStatus = 0
				can = true
			end
		end
		
		if num == 11 then
			self.InstalledBipod = false
			self:SetDTBool(1, false)
			can = true
		elseif num == 10 then
			if self.InstalledLaser then
				self.HipCone = self.HipCone / 0.85
				self.VelocitySensivity = self.VelocitySensivity / 0.75
				self.InaccAff1 = self.InaccAff1 / 0.85
				self.InstalledLaser = false
				can = true
			end
		elseif num == 8 then
			if self.CMagInstalled then
				clip = self:Clip1()
				ammo = self.Owner:GetAmmoCount(self.Primary.Ammo)
				
				self:SetClip1(0)
				self.Owner:SetAmmo(ammo + clip, self:GetPrimaryAmmoType())
				self.Primary.ClipSize = self.Primary.ClipSize_Orig
				self.ReloadSpeed = 1
				self.CMagInstalled = false
				can = true
			
				umsg.Start("NWSPD")
					umsg.Entity(self)
					umsg.Float(1)
				umsg.End()
			end
		elseif num == 7 then
			if self.InstalledGrip then
				if self:IsLastAtt(6) then
					self.VelocitySensivity = self.VelocitySensivity / 0.65
					self.DefRecoil = self.DefRecoil / 0.8
					self.Primary.Recoil = self.DefRecoil
					self.InstalledGrip = false
					self.ConeInaccuracyAff1 = self.ConeInaccuracyAff1 / 0.5
				end
				
				self.SecondaryAtt = 0
				self.Grenade = false
				can = true
			end
		elseif num == 6 then
			if self.SecondaryAtt == 1 then
				self.Grenade = false
				self.InstalledGrip = false
				self.SecondaryAtt = 0
				can = true
			end
		end
		
		if can then
			self.ReloadDelay = CT + 0.15
			
			umsg.Start("NWRATT")
				umsg.Entity(self)
				umsg.Short(num)
			umsg.End()
		end
	end
end

if CLIENT then
	local b2, found, t
	local vcret, tid = vgui.Create, surface.GetTextureID
	
	function SWEP.PlayerBindPress(ply, b, p)
		if p then
			wep = ply:GetActiveWeapon()
			
			if not wep.IsCustomWeapon or not wep:GetClass():find("cstm_") then
				return
			end
				
			if b == "+menu_context" then
				RunConsoleCommand("cstm_requestpimp")
				return true
			else
				if wep:GetDTInt(3) == 19 then
					if b:find("slot") then
						b2 = tonumber(string.Right(b, 1))
						t = wep.Attachments[b2]
						
						if t then
							found = false
							
							if not t.last then
								t.last = {}
							end
							
							for k, v in pairs(t) do
								if table.HasValue(AttOnMe, v) then
									if not table.HasValue(t.last, v) then
										RunConsoleCommand("cstm_pimpmygun", AttEnum[v])
										found = true
										break
									end
								end
							end
							
							if not found then
								RunConsoleCommand("cstm_unpimpmygun", AttEnum[t.last[#t.last]])
							end
							
							return true
						end
					end
				end
			end
		end
	end
	
	hook.Add("PlayerBindPress", "SWEP.PlayerBindPress (CSTM)", SWEP.PlayerBindPress)
	
	function SWEP:DoImpactEffect(trace, dmgtype)
		if not self.Em then
			self.Em = ParticleEmitter(Vector(0, 0, 0))
		end
		
		if self:GetDTInt(2) != 1 then
			return
		end
		
		dlight = DynamicLight(self.Owner:EntIndex())
		
		dlight.Pos = trace.HitPos
		dlight.r = 255
		dlight.g = 170
		dlight.b = 0
		dlight.Brightness = 1
		dlight.Size = 128
		dlight.Decay = 512
		dlight.DieTime = CurTime() + 0.2
		
		ParticleEffect("cstm_incendiary_hit", trace.HitPos, trace.HitNormal:Angle(), nil)
	end
	
	local add

	function SWEP:AdjustMouseSensitivity()
		if self:GetDTBool(1) then
			add = 0.1
		else
			add = 0
		end
		
		if self:GetDTInt(3) == 1 then
			return GetConVarNumber("cstm_aim_sensitivity") * self.Owner:GetFOV() - add
		else
			return 1 - add
		end
	end
	
	function SWEP:MuzzleFlosh() -- lololol
		vm = self.Owner:GetViewModel()
		muz = vm:GetAttachment("1")
		muz2 = vm:LookupAttachment("1")
		
		if muz then
			if not self.Em then
				self.Em = ParticleEmitter(muz.Pos)
			end

			if GetConVarNumber("cstm_ef_smoke") > 0 then
				ParticleEffect(self.SmokeEffect or "cstm_child_smoke_small", muz.Pos, self.Owner:EyeAngles(), muz)
			end
		end
				
		if self.dt.Sil then
			return
		end
		
		if (self.VElements and self.VElements["silencer"] != nil and self.Owner:GetActiveWeapon().VElements["silencer"].color.a != 255) or self.VElements and self.VElements["silencer"] == nil then -- I check if it's not nil and then if it's nil to ensure that weapons that don't have a silencer don't bug
			
			if muz then
				if GetConVarNumber("cstm_ef_heat") > 0 then
					local par = self.Em:Add("sprites/heatwave", muz.Pos)
					par:SetStartSize(4)
					par:SetEndSize(1)
					par:SetDieTime(0.3)
				end
			end
			
			if muz2 then			
				if GetConVarNumber("cstm_ef_extramuzzle") > 0 then
					ParticleEffectAttach(self.Muzzle or "cstm_muzzle_pistol", PATTACH_POINT_FOLLOW, vm, muz2)
				end
						
				if GetConVarNumber("cstm_ef_sparks") > 0 then
					ParticleEffectAttach(self.SparkEffect or "cstm_child_sparks_small", PATTACH_POINT_FOLLOW, vm, muz2)
				end
			end
	
		end
	end

	function SWEP:FireAnimationEvent(pos, ang, ev)
		if ev == 5001 then
			if not self.Owner:ShouldDrawLocalPlayer() then
				self:MuzzleFlosh()
				
				if self.dt.Sil then
					return ev == 5001
				end
			end
		end
	end

	local Current = "none"
	local function ReceiveAlpha(um)
		wep = um:ReadEntity()
		alpha = um:ReadShort()
		
		if ValidEntity(wep) then
			wep.VElements["silencer"].color.a = alpha
			
			if wep.WElements["silencer"] then
				wep.WElements["silencer"].color.a = alpha
			end
			
			if wep.VElements["silencer2"] then
				wep.VElements["silencer2"].color.a = alpha
				wep.WElements["silencer2"].color.a = alpha
			end
		end
	end
	
	usermessage.Hook("NWAlpha", ReceiveAlpha)
	
	local Comp = {} -- this is the table in which the system checks if an attachment that's about to be displayed is incompatible with another attachment
	Comp["rail"] = {}
	Comp["aimpoint"] = {"acog", "eotech", "reflex"}
	Comp["acog"] = {"aimpoint", "eotech", "reflex"}
	Comp["eotech"] = {"acog", "aimpoint", "reflex"}
	Comp["reflex"] = {"acog", "aimpoint", "eotech"}
	Comp["grenadelauncher"] = {"vertgrip", "bipod"}
	Comp["vertgrip"] = {"grenadelauncher", "bipod"}
	Comp["bipod"] = {"vertgrip", "grenadelauncher"}
	
	local nw_num, nw_wep
	
	local Enum = {
		[1] = "rail",
		[2] = "acog",
		[3] = "aimpoint",
		[4] = "eotech",
		[6] = "grenadelauncher",
		[7] = "vertgrip",
		[8] = "cmag",
		[9] = "reflex",
		[10] = "laser",
		[11] = "bipod"}
		
	local function DoStuffWithModels(num, ent)
		Current = Enum[num]
		
		if not Current then
			return
		end
		
		if num == 2 or num == 3 then
			if ent.VElements["rail"] then
				ent.VElements["rail"].color.a = 255
			end
			
			if ent.WElements then
				if ent.WElements["rail"] then
					ent.WElements["rail"].color.a = 255
				end
			end
		elseif num == 4 then
			if ent.NoRail != true and ent.EoTechWithRail != true then
				ent.VElements["rail"].color.a = 0
				
				if ent.WElements and ent.WElements["rail"] then
					ent.WElements["rail"].color.a = 0
				end
			elseif ent.EoTechWithRail then
				if ent.VElements["rail"] then
					ent.VElements["rail"].color.a = 255
				end
				
				if ent.WElements then
					if ent.WElements and ent.WElements["rail"] then
						ent.WElements["rail"].color.a = 255
					end
				end
			end
		elseif num == 6 then
			if ent.VElements["vertgrip"] then
				ent.VElements["vertgrip"].color.a = 0
			end
		elseif num == 7 then
			if ent.VElements["grenadelauncher"] then
				ent.VElements["grenadelauncher"].color.a = 0
			end
		end
		
		for k, v in pairs(ent.VElements) do
			if Comp[Current] then
				if table.HasValue(Comp[Current], k) then
					v.color.a = 0
				end
			end
			
			ent.VElements[Current].color.a = 255
		end
			
		if ent.WElements then
			for k, v in pairs(ent.WElements) do
				if Comp[Current] then
					if table.HasValue(Comp[Current], k) then
						v.color.a = 0
					end
				end
			end
			
			if ent.WElements[Current] then
				ent.WElements[Current].color.a = 255
			end
			
			if num == 6 then
				if ent.WElements["vertgrip"] then
					ent.WElements["vertgrip"].color.a = 0
				end
			end
		end
			
		if num == 2 then
			ent.AimPos = ent.ACOGPos
			ent.AimAng = ent.ACOGAng
			ent.HasInstalledScope = true
		elseif num == 3 then
			ent.AimPos = ent.ScopePos
			ent.AimAng = ent.ScopeAng
			ent.HasInstalledScope = true
		elseif num == 4 or num == 9 then
			ent.AimPos = ent.ReflexPos
			ent.AimAng = ent.ReflexAng
			ent.HasInstalledScope = true
		end
		
		ent.ScaleBonesWhenAttached = true
		wep = LocalPlayer():GetActiveWeapon()
		
		if ent == wep then
			surface.PlaySound("weapons/cstm/attach.wav")
			
			for k, v in ipairs(wep.Attachments) do
				for k2, v2 in ipairs(v) do
					if v2 == Current then
						table.insert(wep.Attachments[k].last, Current)
					end
				end
			end
		end
	end
	
	local function ReceiveAttachmentNumber2(um)
		nw_wep = um:ReadEntity()
		nw_num = um:ReadShort()
		
		DoStuffWithModels(nw_num, nw_wep)
	end
	
	usermessage.Hook("NWATT2", ReceiveAttachmentNumber2)
	
	local function RemoveAttachment(um)
		nw_wep = um:ReadEntity()
		nw_num = um:ReadShort()

		if ValidEntity(nw_wep) and nw_wep.VElements then
			Current = Enum[nw_num]
		
			if nw_num == 2 or nw_num == 3 or nw_num == 4 or nw_num == 9 then
				if nw_wep.VElements["rail"] then
					nw_wep.VElements["rail"].color.a = 0
				end
				
				if nw_wep.WElements then
					if nw_wep.WElements["rail"] then
						nw_wep.WElements["rail"].color.a = 0
					end
				end
				
				if nw_num == 4 then
					if nw_wep.EoTechWithRail then
						if nw_wep.VElements["rail"] then
							nw_wep.VElements["rail"].color.a = 0
						end
						
						if nw_wep.WElements then
							if nw_wep.WElements and nw_wep.WElements["rail"] then
								nw_wep.WElements["rail"].color.a = 0
							end
						end
					end
				end
				
				nw_wep.AimPos = nw_wep.AimPos_Orig
				nw_wep.AimAng = nw_wep.AimAng_Orig
				nw_wep.HasInstalledScope = false
			end
			
			nw_wep.VElements[Current].color.a = 0
			
			if nw_wep.WElements then
				if nw_wep.WElements[Current] then
					nw_wep.WElements[Current].color.a = 0
				end
			end
			
			nw_wep.ScaleBonesWhenAttached = false
			
			wep = LocalPlayer():GetActiveWeapon()
			
			if nw_wep == wep then
				surface.PlaySound("weapons/cstm/detach.wav")
				
				for k, v in ipairs(wep.Attachments) do
					for k2, v2 in ipairs(v) do
						if v2 == Current then
							wep.Attachments[k].last = {}
						end
					end
				end
			end
		end
	end
	
	usermessage.Hook("NWRATT", RemoveAttachment)
	
	local amt
	
	local function ReceiveReloadSpeed(um)
		wep = um:ReadEntity()
		amt = um:ReadFloat()
		
		if ValidEntity(wep) then
			wep.ReloadSpeed = amt
		end
	end
	
	usermessage.Hook("NWSPD", ReceiveReloadSpeed)
	
	local function ReceiveHT(um)
		wep = um:ReadEntity()
		
		if ValidEntity(wep) and wep.SetWeaponHoldType then
			wep:SetWeaponHoldType(um:ReadString())
		end
	end
	
	usermessage.Hook("NWHT", ReceiveHT)
	
	local function ReceiveNumBul(um)
		ply = LocalPlayer()
		wep = ply:GetActiveWeapon()
		
		if ValidEntity(ply) and ValidEntity(wep) then
			wep.Primary.NumShots = um:ReadShort()
		end
	end
	
	usermessage.Hook("NBUL", ReceiveNumBul)
	
	local function ReceiveFireMode(um)
		Mode = um:ReadString()
		ply = LocalPlayer()
		wep = ply:GetActiveWeapon()
		
		if ValidEntity(ply) and ValidEntity(wep) then
			if Mode == "semi" then
				wep.Bullets = 1
				wep.Primary.Automatic = false
			elseif Mode == "burst" then
				wep.Bullets = 3
				wep.Primary.Automatic = true
			elseif Mode == "auto" then
				wep.Bullets = 5
				wep.Primary.Automatic = true
			end
		end
	end
	
	usermessage.Hook("FRMD", ReceiveFireMode)
	
	local function CSTM_Recoil()
		ply = LocalPlayer()
		wep = ply:GetActiveWeapon()
		vm = ply:GetViewModel()
		
		wep.RecoilAmt = 1.5
		wep:MuzzleFlosh()
	end
	
	usermessage.Hook("RECOIL", CSTM_Recoil)
	
	local tid, tex, clr, rect, orect, trect, trectuv, trectrot = surface.GetTextureID, surface.SetTexture, surface.SetDrawColor, surface.DrawRect, surface.DrawOutlinedRect, surface.DrawTexturedRect, surface.DrawTexturedRectUV, surface.DrawTexturedRectRotated
	
	local gap = 5
	local gap2 = 0
	local CurAlpha_Weapon = 255
	local BipodAlpha = 0
	local ScopeTexture = tid("gcellmats/scope_rifle2")
	local GLTexture = tid("sprites/crosshair_gl")
	local UseGoggle = false
	local Bullet = tid("VGUI/bullet")
	local Bipod_Active = tid("VGUI/bipod_active")

	function SWEP:DrawHUD()
		FT = RealFrameTime()
		Width = ScrW()
		Height = ScrH()
		
		x2 = (Width - 1024) / 2
		y2 = (Height - 1024) / 2
		x3 = Width - x2
		y3 = Height - y2
		
		dtint3 = self:GetDTInt(3)
		
		if dtint3 == 1 and GetConVarNumber("cstm_oldacog") > 0 and ((self.VElements and self.VElements["acog"] and self.VElements["acog"].color.a == 255) or (self.VElements and self.VElements["ballistic"] and self.VElements["ballistic"].color.a == 255)) then
			if UseGoggle == false then
				TimeToUseGoggle = CurTime() + 0.15
				UseGoggle = true
			end
			
			if CurTime() > TimeToUseGoggle then
				clr(255, 255, 255, 255)
				tex(ScopeTexture)
				trectuv(x2, y2, 1024, 1024, 1024, 1024)
				
				clr(0, 0, 0, 255)
				rect(0, 0, x2, Height)
				rect(x3, 0, x2, Height)
				rect(0, 0, Width, y2)
				rect(0, y3, Width, y2)
			end
		else
			UseGoggle = false
		end
		
		if self:GetDTBool(1) then
			BipodAlpha = Lerp(FT * 15, BipodAlpha, 150)
		else
			BipodAlpha = Lerp(FT * 15, BipodAlpha, 0)
		end
		
		if BipodAlpha > 5 then
			clr(0, 0, 0, BipodAlpha)
			tex(Bipod_Active)
			trect(Width * 0.5 - 60, Height * 0.5 - 60, 32, 32)
			
			clr(255, 210, 0, BipodAlpha)
			trect(Width * 0.5 - 59, Height * 0.5 - 59, 32, 32)
		end
		
		if self.Bullets then
			Text = nil
		
			if self.Bullets == 1 then
				Text = self.SemiText and self.SemiText or "Semi-auto"
			elseif self.Bullets == 3 then
				Text = "Burst"
			elseif self.Bullets == 5 then
				Text = "Full-auto"
			end
			
			draw.RoundedBox(6, Width * 0.5 - 60, Height * 0.9, 120, 30, Color(0, 0, 0, 220))
			draw.SimpleText(Text, "DefaultSmallDropShadow", Width * 0.5, Height * 0.9 + 10, Color(255, 255, 255, 255), TEXT_ALIGN_CENTER, TEXT_ALIGN_CENTER)	

			clr(255, 210, 0, 255)			
			tex(Bullet)
			
			if self.Bullets == 1 then
				trectrot(Width * 0.5, Height * 0.9 + 20, 16, 16, 180)
			elseif self.Bullets == 3 then
			
				for i = 1, 3 do
					trectrot(Width * 0.5 + 20 * i - 40, Height * 0.9 + 20, 16, 16, 180)
				end
				
			else
			
				for i = 1, 5 do
					trectrot(Width * 0.5 + 20 * i - 60, Height * 0.9 + 20, 16, 16, 180)
				end
			end
		end	
	
		if ( self.Owner == LocalPlayer() && self.Owner:ShouldDrawLocalPlayer() ) then

			tr = util.GetPlayerTrace( self.Owner )
			tr.mask = ( CONTENTS_SOLID|CONTENTS_MOVEABLE|CONTENTS_MONSTER|CONTENTS_WINDOW|CONTENTS_DEBRIS|CONTENTS_GRATE|CONTENTS_AUX )
			trace = util.TraceLine( tr )
			
			coords = trace.HitPos:ToScreen()
			x, y = coords.x, coords.y

		else
			x, y = Width / 2.0, Height / 2.0
		end
		
		if dtint3 == 2 or dtint3 == 4 or dtint3 == 19 then
			CurAlpha_Weapon = app(CurAlpha_Weapon, 0, FT / 0.001)
		elseif (dtint3 == 1 and self.NoProperIronsights != true) or UseGoggle == true or (dtint3 == 1 and self.HasInstalledScope == true) then
			CurAlpha_Weapon = app(CurAlpha_Weapon, 0, FT / 0.001)
		elseif dtint3 == 0 or dtint3 == 3 or dtint3 == 18 then
			CurAlpha_Weapon = app(CurAlpha_Weapon, 255, FT / 0.001)
		end
		
		if not self.DisableCrosshair then
			scale = (10 / (self.Owner:GetFOV() / 90)) * self:GetDTFloat(0)
			
			gap = Lerp(0.25, gap, scale * 50)
			
			if GetConVarNumber("cstm_dynamiccrosshair") > 0 then
				gap2 = gap
			else
				gap2 = 0
			end
		
			if dtint3 != 8 then
				out_r = GetConVarNumber("cstm_out_r")
				out_g = GetConVarNumber("cstm_out_g")
				out_b = GetConVarNumber("cstm_out_b")
				out_a = GetConVarNumber("cstm_out_a")
				
				in_r = GetConVarNumber("cstm_in_r")
				in_g = GetConVarNumber("cstm_in_g")
				in_b = GetConVarNumber("cstm_in_b")
				in_a = GetConVarNumber("cstm_in_a")
				
				cl = GetConVarNumber("cstm_crosslength")
				
				if GetConVarNumber("cstm_leftcross") > 0 then
					clr(out_r, out_g, out_b, CurAlpha_Weapon * (out_a / 255))
					rect(x - gap - cl - (gap2 * 0.2), y - 1, cl + 2 + (gap2 * 0.2), 3)
					clr(in_r, in_g, in_b, CurAlpha_Weapon * (in_a / 255))
					rect(x - gap - (cl - 1) - (gap2 * 0.2), y, cl + (gap2 * 0.2), 1)
				end
				
				if GetConVarNumber("cstm_rightcross") > 0 then
					clr(out_r, out_g, out_b, CurAlpha_Weapon * (out_a / 255))
					rect(x + gap - 1, y - 1, cl + 2 + (gap2 * 0.2), 3)
					clr(in_r, in_g, in_b, CurAlpha_Weapon * (in_a / 255))
					rect(x + gap, y, cl + (gap2 * 0.2), 1)
				end
				
				if GetConVarNumber("cstm_lowercross") > 0 then
					clr(out_r, out_g, out_b, CurAlpha_Weapon * (out_a / 255))
					rect(x - 1, y + gap - 1, 3, cl + 2 + (gap2 * 0.2))
					clr(in_r, in_g, in_b, CurAlpha_Weapon * (in_a / 255))
					rect(x , y + gap, 1, cl + (gap2 * 0.2))
				end
				
				if GetConVarNumber("cstm_uppercross") > 0 then
					clr(out_r, out_g, out_b, CurAlpha_Weapon * (out_a / 255))
					rect(x - 1, y - gap - cl - (gap2 * 0.2), 3, cl + 2 + (gap2 * 0.2))
					clr(in_r, in_g, in_b, CurAlpha_Weapon * (in_a / 255))
					rect(x, y - gap - (cl - 1) - (gap2 * 0.2), 1, cl + (gap2 * 0.2))
				end
			else
				clr(255, 255, 255, 255)
				tex(GLTexture)
				trect(Width / 2 - 64, Height / 2, 128, 128)
			end
		end
	end
	
	function SWEP:DrawWeaponSelection( x, y, wide, tall, alpha )
		if self.DifType then
			clr(255, 210, 0, 255)
			tex(self.WepSelectIcon)
			trect(x + 56, y, 128, 128)
		else
			draw.SimpleText( self.IconLetter, "CSSelectIcons", x + wide/2, y + tall*0.2, Color( 255, 210, 0, 255 ), TEXT_ALIGN_CENTER )
		end
	end
end

local HideModel = false

function SWEP:SecondaryAttack()
	tr = self.Owner:GetEyeTrace()
	
	if tr.HitPos:Distance(self.Owner:GetShootPos()) < 30 then
		return
	end
	
	dtint3 = self:GetDTInt(3)
	
	if dtint3 == 2 or dtint3 == 18 or dtint3 == 19 or not self.Owner:OnGround() or self.Owner:KeyDown(IN_SPEED) or self.ShouldBolt == true then
		return
	end
	
	CT = CurTime()

	if self.Owner:KeyDown(IN_USE) and dtint3 != 1 then
		if self.CantSilence == true then
			return
		end
	
		if not self.dt.Sil then
			
			if SERVER then
				self:SetDTInt(3, 6)
				
				tsim(0.5, function()
					if self.Weapon == nil then
						return
					end
					
					self.Owner:EmitSound("weapons/usp/usp_silencer_on.wav", 50, rand(99, 101))
					self.Owner:DoAnimationEvent(ACT_ITEM_GIVE)
				end)
				
				tsim(2, function()
					if self.Weapon == nil then
						return
					end
					
					self:NWAlpha(255)
					self.dt.Sil = true
					self:SetDTInt(3, 7)
				end)
			end
			
		else
			if SERVER then
				self:SetDTInt(3, 6)
				
				tsim(0.5, function()
					if self.Weapon == nil then
						return
					end
					
					self.Owner:EmitSound("weapons/usp/usp_silencer_off.wav", 50, rand(99, 101))
					self.Owner:DoAnimationEvent(ACT_ITEM_GIVE)
				end)
				
				tsim(1.8, function()
					if self.Weapon == nil then
						return
					end
					
					self:NWAlpha(1)
					self.dt.Sil = false
					self:SetDTInt(3, 7)
				end)
			end
			
		end
		
		self:SetNextPrimaryFire(CT + 2.35)
		self:SetNextSecondaryFire(CT + 2.35)
		self.ReloadDelay = CT + 2.35
		self.Owner.AttachDelay = CT + 2.35
		
		return
	end
	
	if (dtint3 == 0 or dtint3 == 3 or dtint3 == 7) then
	
		if not self.CanAimWithRail and self.HasRail and self.ScopeStatus == 0 and self.RequiresRail then
			return
		end
	
		if SERVER then
		
			if self.Grenade then
				self:SetDTInt(3, 8)
			else
				self:SetDTInt(3, 1)
			end
		
			if self.ScopeStatus >= 2 and not self.Grenade then
				fov = nil
				ScopeStatus = self.ScopeStatus
					
				if ScopeStatus == 0 then
					fov = 75
				elseif ScopeStatus == 2 then
					if tonumber(self.Owner:GetInfo("cstm_oldacog")) <= 0 then
						fov = 67
					else
						fov = 40
						
						tsim(0.15, function()
							if self.Weapon != self.Owner:GetActiveWeapon() or self:GetDTInt(3) != 1 then
								return
							end
							
							self.Owner:DrawViewModel(false)
							
						end)
					end
				elseif ScopeStatus == 3 then
					fov = 67
				elseif ScopeStatus == 9 then
					fov = 72
				elseif ScopeStatus == 4 then
					fov = 72
				elseif ScopeStatus == 5 then
					fov = 15
				else
					fov = 67
				end
				
				self.Owner:SetFOV(fov, 0.3)
			else
				self.Owner:SetFOV(75, 0.3)
			end
			
		end
	elseif dtint3 == 1 or dtint3 == 8 then
		self:SetDTInt(3, 0)
		
		if SERVER then
			self.Owner:SetFOV(0, 0.3)
			self.Owner:DrawViewModel(true)
		end
	end
	
	self:SetNextPrimaryFire(CT + 0.2)
	self.NextSecondaryAttack = CT + 0.3
	
end

function SWEP:OnRestore()
	self:SetDTInt(3, 0)
end

local s

function SWEP:SendAllAttachments()
	s = ""
	
	if self.ScopeStatus != 0 then
		s = s .. " " .. self.ScopeStatus
	end
	
	if self.InstalledLaser then
		s = s .. " 10"
	end
	
	if self.CMagInstalled then
		s = s .. " 8"
	end
	
	if self.InstalledGrip then
		s = s .. " 7"
	end
	
	if self.SecondaryAtt == 1 then
		s = s .. " 6"
	end
	
	if self.dt.Sil and not self.DifferentSilencer then
		self:NWAlpha(255)
	end
	
	umsg.Start("NWATT2ALL")
		umsg.Entity(self)
		umsg.String(s)
	umsg.End()
end

if SERVER then
	function SWEP:Melee(ply, wep)
		if wep.ReloadTime then
			return
		end
		
		CT = CurTime()
		
		if CT < wep.MeleeDelay then
			return
		end
		
		wep:SetDTInt(3, 15)
		
		wep.MeleeDelay = CT + 0.5
		wep.ReloadDelay = CT + 0.5
		wep.AttachDelay = CT + 0.5
		wep:SetNextPrimaryFire(CT + 0.5)
		wep:SetNextSecondaryFire(CT + 0.5)
		
		ply:EmitSound("npc/fast_zombie/claw_miss1.wav", 80, 100)
		ply:ViewPunch(Vector(-5, 10, 0))
		
		tsim(0.1, function()
		
			if not wep or not ply or ply:GetActiveWeapon():GetClass() != wep:GetClass() then
				return
			end
			
			tr.start = ply:GetShootPos()
			tr.endpos = tr.start + ply:GetAimVector() * 50
			tr.filter = ply
			tr.mins = Vector(-8, -8, -8)
			tr.maxs = Vector(8, 8, 8)
			
			trace = util.TraceHull(tr)
			
			if trace.Hit then
			
				physobj = trace.Entity:GetPhysicsObject()
					
				if physobj:IsValid() then
					physobj:AddVelocity(ply:GetAimVector() * 250)
				end
					
				if trace.Entity:IsPlayer() or trace.Entity:IsNPC() or trace.Entity:Health() > 0 then
					trace.Entity:TakeDamage(rand(wep.MeleeDamageMin, wep.MeleeDamageMax), ply, ply)
					
					if trace.Entity:IsNPC() then
						trace.Entity:SetVelocity(ply:GetForward() * 2000)
					end
				end
				
				ply:EmitSound("physics/body/body_medium_impact_hard" .. rand(1, 6) .. ".wav", 80, 100)
			end
			
		end)
		
		tsim(0.25, function()
			wep:SetDTInt(3, 0)
		end)
	end

	concommand.Add("cstm_melee", function(ply)
		wep = ply:GetActiveWeapon()
		
		if wep.IsCustomWeapon and wep:GetDTInt(3) == 0 then
			wep:Melee(ply, wep)
		end
	end)
end