
if (SERVER) then

	AddCSLuaFile( "shared.lua" )
	SWEP.Weight				= 5
	SWEP.AutoSwitchTo		= false
	SWEP.AutoSwitchFrom		= false

end

if ( CLIENT ) then

	SWEP.DrawAmmo			= true
	SWEP.DrawCrosshair		= false
	SWEP.ViewModelFOV		= 75
	SWEP.ViewModelFlip		= true
	SWEP.CSMuzzleFlashes	= true
	SWEP.PitchMod = 1
	SWEP.RollMod = 1
	// This is the font that's used to draw the death icons
	surface.CreateFont( "csd", ScreenScale( 30 ), 500, true, true, "CSKillIcons" )
	surface.CreateFont( "csd", ScreenScale( 60 ), 500, true, true, "CSSelectIcons" )

end

SWEP.Author			= "LEETNOOB"
SWEP.Contact		= ""
SWEP.Purpose		= ""
SWEP.Instructions	= "PRIMARY ATTACK key to fire\nSECONDARY ATTACK key to toggle ironsights\nUSE key + SECONDARY ATTACK key - attach suppressor\nUSE key + RELOAD key - switch between semi-auto/auto firemodes (SMGs/ARs)\nCONTEXT MENU KEY - open attachment selection menu\nWHILE IN MENU - press numbers in brackets on the keyboard to select attachments"

// Note: This is how it should have worked. The base weapon would set the category
// then all of the children would have inherited that.
// But a lot of SWEPS have based themselves on this base (probably not on purpose)
// So the category name is now defined in all of the child SWEPS.
//SWEP.Category			= "Counter-Strike"

SWEP.Spawnable			= false
SWEP.AdminSpawnable		= false

SWEP.Primary.Sound			= Sound( "Weapon_AK47.Single" )
SWEP.Primary.Recoil			= 1.5
SWEP.Primary.Damage			= 40
SWEP.Primary.NumShots		= 1
SWEP.Primary.Cone			= 0.02
SWEP.Primary.Delay			= 0.15

SWEP.Primary.ClipSize		= -1
SWEP.Primary.DefaultClip	= -1
SWEP.Primary.Automatic		= false
SWEP.Primary.Ammo			= "none"

SWEP.Secondary.ClipSize		= -1
SWEP.Secondary.DefaultClip	= -1
SWEP.Secondary.Automatic	= false
SWEP.Secondary.Ammo			= "none"
SWEP.Base					= "cstm_base_pistol"

local CT, vm, sequence, AvailableReload, nick, wep, DTInt3, ent, AimVec, EyeAng, Offset, RecMod, bullet
local destr, tsim, tcret, app, clamp, sin, cos, rand, rand2 = timer.Destroy, timer.Simple, timer.Create, math.Approach, math.Clamp, math.sin, math.cos, math.random, math.Rand


function SWEP:Deploy()
	CT = CurTime()

	self:SendWeaponAnim(ACT_VM_DRAW)
	self:SetNextPrimaryFire(CT + 1)
	self:SetNextSecondaryFire(CT + 1)
	self.ReloadDelay = CT + 1
	self.MeleeDelay = CT + 1
	self.HolsterStatus = 0
	self:SetDTInt(3, 0)
	
	return true
end
	
function SWEP:Reload()
	if self.ReloadTime then
		return
	end
	
	if self.Owner:GetAmmoCount(self.Primary.Ammo) > 0 then
		if self:Clip1() < self.Primary.ClipSize then
			if CurTime() > self.ReloadDelay then
				self:StartCustomReload("start_reload", self.ReloadSpeed)
				self:SetDTInt(3, 0)
				
				if SERVER then
					if self.Owner:GetFOV() != 0 then
						self.Owner:SetFOV(0, 0.3)
					end
				end
			end
		end
	end
end

function SWEP:StartCustomReload(anim, ReloadSpeed)
	vm = self.Owner:GetViewModel()
	sequence = vm:LookupSequence(anim)
	vm:ResetSequence(sequence)
	vm:SetPlaybackRate(ReloadSpeed)
	
	if self:Clip1() == 0 then
		self.ShouldBolt = true
	end
	
	AvailableReload = clamp(self.Owner:GetAmmoCount(self.Primary.Ammo), 0, 1)
	CT = CurTime()
	self.ReloadTime = CT + vm:SequenceDuration() / self.ReloadSpeed
	self:SetNextPrimaryFire(CurTime() + 1)
end

function SWEP:FinishCustomReload(bolt)
	vm = self.Owner:GetViewModel()
	CT = CurTime()

	if bolt == false or self.NoBoltAnim == true then
		self.ShouldBolt = false
		self.ReloadTime = nil
		sequence = vm:LookupSequence("idle")
		vm:ResetSequence(sequence)
		vm:SetSequence(sequence)
		vm:SetPlaybackRate(self.ReloadSpeed)
		self:SetNextPrimaryFire(CT + 0.3)
		self:SetNextSecondaryFire(CT + 0.3)
		self.MeleeDelay = CT + 0.3
	else
		self:BoltWeaponry()
	end
end

function SWEP:BoltWeaponry()
	vm = self.Owner:GetViewModel()
	CT = CurTime()

	sequence = vm:LookupSequence("after_reload")
	vm:ResetSequence(sequence)
	vm:SetSequence(sequence)
	vm:SetPlaybackRate(self.ReloadSpeed)
	
	tsim((vm:SequenceDuration() / self.ReloadSpeed) - 0.2, function()
		self.ShouldBolt = false
	end)
	
	self:SetNextPrimaryFire(CT + 0.8)
	self:SetNextSecondaryFire(CT + 0.8)
end

function SWEP:Think()	
	CT = CurTime()
	
	if self.ReloadTime then
		clip = self:Clip1()
		
		if CT > self.ReloadTime then
			if clip < self.Primary.ClipSize then
				if not self.StopAnim then
					self:SendWeaponAnim(ACT_VM_IDLE)
					
					if CT > self.ReloadTime + 0.02 then
						self:SendWeaponAnim(ACT_VM_RELOAD)
						self.StopAnim = true
					end
				end
			end
			
			if CT > self.ReloadTime + 0.3 then
				if clip < self.Primary.ClipSize and self.Owner:GetAmmoCount(self.Primary.Ammo) - 1 > 0 then
					self:SetClip1(clip + 1)
					self.Owner:RemoveAmmo(1, self.Primary.Ammo)
					self.ReloadTime = CT + self.IncAmmoPerc
				else
					self:FinishCustomReload(self.ShouldBolt)
				end
				
				self.StopAnim = false
			end
		end
	end
		
	if SERVER then
		AimVec = self.Owner:GetAimVector()
		
		if not self.Owner.LastView then
			self.Owner.LastView = AimVec
			self.Owner.ViewAff = 0
		else
			self.Owner.ViewAff = Lerp(0.25, self.Owner.ViewAff, (AimVec - self.Owner.LastView):Length() * 0.15)
			self.Owner.LastView = AimVec
		end
	
		self.Primary.Cone = clamp((self.CurCone + self.ConeInaccuracy + ((self.Owner:GetVelocity():Length() / 10000) * (self:GetDTInt(3) == 1 and self.VelocitySensivity * 0.3 or self.VelocitySensivity)) - (self.ConeAff1 + self.ConeAff3) + self.Owner.ViewAff), 0.002, 0.15)
		self:SetDTFloat(0, clamp(self.Primary.Cone, 0.002, 0.12 * (1 - (self.RecoilAff1 + self.RecoilAff2))))
		
		if CT > self.ConeInaccDelay then
			self.ConeInaccuracy = clamp(self.ConeInaccuracy - 0.0015, 0, 0.08 * self.ConeInaccuracyAff1)
		end
	
		if self.Owner:Crouching() and self.Owner:OnGround() then
			self.ConeAff1 = 0.005
			self.ConeDecAff1 = 0.0025
			self.RecoilAff2 = 0.3
		else
			self.ConeAff1 = 0
			self.ConeDecAff1 = 0
			self.RecoilAff2 = 0
		end
		
		if self.IsSilenced then
			self.RecoilAff3 = 0.15
		else
			self.RecoilAff3 = 0
		end
		
		if self:GetDTInt(3) == 1 then
			self.ConeDecAff2 = 0.0045
			self.RecoilAff1 = 0.3
			
			self.CurCone = self.IronsightsCone / GetConVarNumber("cstm_accuracymod_aim")
			
			if self.HeadbobMul == 1 then
				self.HeadbobMul = 0.4
			end
			
			if (self:GetClass():find("^cstm_rif_") or self:GetClass():find("^cstm_sniper_")) and not self.Primary.Automatic then
				self.ConeAff3 = 0.003
			else
				self.ConeAff3 = 0
			end
		elseif self:GetDTInt(3) == 17 then
			self.ConeDecAff2 = 0.0045
			self.RecoilAff1 = 0.5
			self.CurCone = self.IronsightsCone / GetConVarNumber("cstm_accuracymod_aim")
		else
			self.ConeDecAff2 = 0
			self.RecoilAff1 = 0
			self.CurCone = self.HipCone / GetConVarNumber("cstm_accuracymod_hip")
			
			if self.HeadbobMul == 0.4 then
				self.HeadbobMul = 1
			end
			
			if self:GetClass():find("^cstm_rif_") or self:GetClass():find("^cstm_sniper_") then
				self.ConeAff3 = 0
			end
		end
		
		if self:GetDTInt(3) == 1 then
			if not self.Owner:KeyDown(IN_ATTACK2) then
				if tonumber(self.Owner:GetInfo("cstm_hold_to_aim")) > 0 then
					self:SetDTInt(3, 0)
					self.Owner:SetFOV(0, 0.3)
					self.Owner:DrawViewModel(true)
				end
			end
		end
		
	end
	
	if not self.Owner:KeyDown(IN_ATTACK) and self.NumShots != 0 and self.Burst then
		self:SetNextPrimaryFire(CurTime() + self.Primary.Delay * 2)
		self.NumShots = 0
	end
	
	dtint3 = self:GetDTInt(3)
	wepclass = self:GetClass()
	
	if self.Owner:KeyDown(IN_SPEED) and self.Owner:OnGround() and dtint3 != 6 and dtint3 != 10 and dtint3 != 15 and dtint3 != 17 and dtint3 != 18 then 
		if self.Owner:GetVelocity():Length() > self.Owner:GetWalkSpeed() then
			if dtint3 != 2 and dtint3 != 15 and dtint3 != 18 then
				if wepclass:find("^cstm_pistol_") then
					self:SetDTInt(3, 18)
				else
					self:SetDTInt(3, 2)
				end
				
				if SERVER then
					self.Owner:SetFOV(0, 0.3)
					self.Owner:DrawViewModel(true)
				end
			end
			
		else
			if dtint3 != 1 or dtint3 != 8 and dtint3 != 10 and dtint3 != 11 and dtint3 != 12 and dtint3 != 15 and dtint3 != 17 and dtint3 != 18 then
				self:SetDTInt(3, 0)
				
				if SERVER then
					self.Owner:SetFOV(0, 0.3)
					self.Owner:DrawViewModel(true)
				end
			end
		end
	elseif not self.Owner:KeyDown(IN_SPEED) and dtint3 != 1 and dtint3 != 0 and dtint3 != 6 and dtint3 != 8 and dtint3 != 10 and dtint3 != 11 and dtint3 != 12 and dtint3 != 15 and dtint3 != 17 and dtint3 != 19 or not self.Owner:OnGround() and dtint3 != 6 and dtint3 != 0 and dtint3 != 15 and dtint3 != 17 then
		self:SetDTInt(3, 0)
		
		if SERVER then
			self.Owner:SetFOV(0, 0.2)
			self.Owner:DrawViewModel(true)
		end
	end
	
	if not self.Owner:KeyDown(IN_RELOAD) then
		if self.HasReleasedKey == false then
			self.HasReleasedKey = true
		end
	end
	
	if self.Burst and not self.Owner:KeyDown(IN_ATTACK) then
		self.Shots = 0
	end
	
	if CLIENT then
		self.Owner:GetViewModel().BuildBonePositions = function(self, numbon, numphysbon)
		
			if not ValidEntity(LocalPlayer():GetActiveWeapon()) then
				return
			end
			
			ply = LocalPlayer()
			vm = ply:GetViewModel()
			wep = ply:GetActiveWeapon()
			activity = wep:GetSequenceActivityName(wep:GetSequence())
			seqdur = vm:SequenceDuration()
			FT = FrameTime()
			
			if not wep.IsCustomWeapon then
				return
			end
			
			if ValidEntity(wep) then
				if wep.MagBone then
					if wep.VElements and wep.VElements["cmag"].color.a == 255 then 
						bone = vm:LookupBone(wep.MagBone)
						matrix = vm:GetBoneMatrix(bone)
							
						if matrix then
							matrix:Scale(Vector(0.01, 0.01, 0.01))
							vm:SetBoneMatrix(bone, matrix)
						end
					end
				end
				
				if wep.OtherBone then
					if wep.VElements and ((wep.VElements["eotech"] and wep.VElements["eotech"].color.a == 255) or (wep.VElements["aimpoint"] and wep.VElements["aimpoint"].color.a == 255) or (wep.VElements["acog"] and wep.VElements["acog"].color.a == 255)) then
						bone = vm:LookupBone(wep.OtherBone)
						matrix = vm:GetBoneMatrix(bone)
							
						if matrix then
							matrix:Scale(Vector(0.01, 0.01, 0.01))
							vm:SetBoneMatrix(bone, matrix)
						end
					end
				end

				if wep.ViewModelBonescales then
					for k, v in pairs( wep.ViewModelBonescales ) do
						bone = vm:LookupBone(k)
						if (!bone) then continue end
						m = vm:GetBoneMatrix(bone)
						if (!m) then continue end
						m:Scale(v)
						vm:SetBoneMatrix(bone, m)
					end
				end
			
				if self.ViewModelBonescales then
					for k, v in pairs( self.ViewModelBonescales ) do
						bone = s:LookupBone(k)
						if (!bone) then continue end
						m = s:GetBoneMatrix(bone)
						if (!m) then continue end
						m:Scale(v)
						s:SetBoneMatrix(bone, m)
					end
				end
			
				if wep:GetDTInt(3) == 15 then
					if wep.MeleeOffset then
						wep.TargetOffset = wep.MeleeOffset
					else
						if wep.VElements["vertgrip"] and wep.VElements["vertgrip"].color.a == 255 then
							wep.TargetOffset = wep.VertGrip_Idle
						elseif wep.VElements["cmag"] and wep.VElements["cmag"].color.a == 255 then
							wep.TargetOffset = wep.CMag_Idle
						end
					end
				else
					if wep.VElements and (wep.VElements["grenadelauncher"] or wep.VElements["vertgrip"] or wep.VElements["cmag"]) then
					
						if wep.VElements["grenadelauncher"] and wep.VElements["grenadelauncher"].color.a == 255 then
						
							if activity == "ACT_VM_RELOAD" or activity == "ACT_VM_RELOAD_SILENCED" or activity == "ACT_VM_DETACH_SILENCER" or activity == "ACT_VM_ATTACH_SILENCER" then
							
								if wep.OffsetMeStage == 1 then
									wep.TargetOffset = "none"
								elseif wep.OffsetMeStage == 2 then
									wep.TargetOffset = wep.GrenadeLauncher_Idle
								end
							else
								if wep:GetDTInt(3) == 8 then
									wep.TargetOffset = wep.GrenadeLauncher_Active
								else
									wep.TargetOffset = wep.GrenadeLauncher_Idle
								end
							end
			
						elseif wep.VElements["vertgrip"] and wep.VElements["vertgrip"].color.a == 255 then
							if activity == "ACT_VM_RELOAD" or activity == "ACT_VM_RELOAD_SILENCED" then
								if wep.VElements["cmag"] and wep.VElements["cmag"].color.a == 255 then
									if wep.OffsetMeStage == 1 then
										wep.TargetOffset = "none"
									elseif wep.OffsetMeStage == 2 then
										wep.TargetOffset = wep.CMag_Reload or "none"
									end
								else
									if wep.OffsetMeStage == 1 then
										wep.TargetOffset = "none"
									elseif wep.OffsetMeStage == 2 then
										wep.TargetOffset = wep.VertGrip_Idle
									end
								end
							elseif activity == "ACT_VM_ATTACH_SILENCER" or activity == "ACT_VM_DETACH_SILENCER" or (activity == "ACT_VM_DRAW" and wep.NoMoveOnDraw) then
								if (activity == "ACT_VM_DRAW" and wep.NoMoveOnDraw) then
								end
								
								if wep.OffsetMeStage == 1 then
									wep.TargetOffset = "none"
								elseif wep.OffsetMeStage == 2 then
									wep.TargetOffset = wep.VertGrip_Idle
								end
							else
								wep.TargetOffset = wep.VertGrip_Idle
							end
						else
							if wep.VElements["cmag"] and wep.VElements["cmag"].color.a == 255 then
								if activity == "ACT_VM_RELOAD" or activity == "ACT_VM_RELOAD_SILENCED" then
									if wep.OffsetMeStage == 1 then
										wep.TargetOffset = "none"
									elseif wep.OffsetMeStage == 2 then
										wep.TargetOffset = wep.CMag_Reload or "none"
									end
								elseif activity == "ACT_VM_ATTACH_SILENCER" or activity == "ACT_VM_DETACH_SILENCER" then
									if wep.OffsetMeStage == 1 then
										wep.TargetOffset = "none"
									elseif wep.OffsetMeStage == 2 then
										wep.TargetOffset = wep.CMag_Idle
									end
								else
									wep.TargetOffset = wep.CMag_Idle
								end
							else
								wep.TargetOffset = {}
							end
						end
					else
						wep.TargetOffset = "none"
					end
				end
				
				if wep.TargetOffset == "none" and wep.OffsetBones then
					for k, v in pairs(wep.OffsetBones) do
					
						wep.OffsetBones[k] = wep.OffsetBones[k] or {}
					
						if v.curoffset then	
							v.curoffset = LerpVector(FT * 27, v.curoffset, Vector(0, 0, 0))
						end
						
						if v.currotation then
							v.currotation = LerpVector(FT * 27, v.currotation, Vector(0, 0, 0))
						end
					
						bone = vm:LookupBone(k)
						matrix = self:GetBoneMatrix(bone)
								
						if matrix then
							if v.curoffset then
								matrix:Translate(wep.OffsetBones[k].curoffset)
							end
							
							if v.currotation then
								matrix:Rotate(wep.OffsetBones[k].currotation)
							end
							
							self:SetBoneMatrix(bone, matrix)
						end
					end
				else
					if wep.TargetOffset and wep.TargetOffset != "none" then
						for k, v in pairs(wep.TargetOffset) do
							
							wep.OffsetBones[k] = wep.OffsetBones[k] or {}
						
							if not wep.OffsetBones[k].curoffset and not wep.OffsetBones[k].currotation then
								wep.OffsetBones[k].curoffset = Vector(0, 0, 0)
								wep.OffsetBones[k].currotation = Vector(0, 0, 0)
							end
							
							if wep.OffsetMeStage == 1 then
								wep.OffsetBones[k].curoffset = LerpVector(FT * 27, wep.OffsetBones[k].curoffset, v.vector or Vector(0, 0, 0))
								wep.OffsetBones[k].currotation = LerpVector(FT * 27, wep.OffsetBones[k].currotation, v.angle or Vector(0, 0, 0))
							elseif wep.OffsetMeStage == 2 then
								wep.OffsetBones[k].curoffset = LerpVector(FT * 27, wep.OffsetBones[k].curoffset, v.vector)
								wep.OffsetBones[k].currotation = LerpVector(FT * 27, wep.OffsetBones[k].currotation, v.angle)
							end
							
							bone = vm:LookupBone(k)
							matrix = self:GetBoneMatrix(bone)
							
							if matrix then
								matrix:Translate(wep.OffsetBones[k].curoffset)
								matrix:Rotate(wep.OffsetBones[k].currotation)
								self:SetBoneMatrix(bone, matrix)
							end
								
						end
					end
				end
					
				if (activity == "ACT_VM_RELOAD" or activity == "ACT_VM_RELOAD_SILENCED" or activity == "ACT_VM_ATTACH_SILENCER" or activity == "ACT_VM_DETACH_SILENCER") or (activity == "ACT_VM_DRAW" and wep.NoMoveOnDraw) and not wep:GetClass():find("^cstm_shotgun") then
					if not wep.TimerCreated then
						wep.OffsetMeStage = 1
						
						TimeRel, TimeIdle = nil, nil
						
						if wep:Clip1() > 0 and (activity == "ACT_VM_RELOAD" or activity == "ACT_VM_RELOAD_SILENCED") then
							TimeRel = (seqdur * wep.IncAmmoPerc) / wep.ReloadSpeed
							TimeIdle = (seqdur * wep.IncAmmoPerc) / wep.ReloadSpeed
						else
							TimeRel = (seqdur / wep.ReloadSpeed) - 0.5
							TimeIdle = (seqdur / wep.ReloadSpeed) - 0.01
						end
						
						tsim(TimeRel, function()
							wep.OffsetMeStage = 2
						end)
					
						if wep:Clip1() != 0 then
							if not wep.SkipIdle then
								tsim(TimeIdle, function()
									wep:SendWeaponAnim(ACT_VM_IDLE)
								end)
							end
						end
						
						wep.TimerCreated = true
					end
				else
					wep.TimerCreated = false
					wep.OffsetMeStage = 2
				end
			end
		end
	end
end

function SWEP:PrimaryAttack()
	if self.ReloadTime then
		self.ReloadTime = nil
		self:FinishCustomReload(self.ShouldBolt)
		return
	end
	
	DTInt3 = self:GetDTInt(3)
	
	if DTInt3 == 19 then
		return
	end
	
	nick = self.Owner:Nick()
	CT = CurTime()
	
	if self:Clip1() == 0 or self.Owner:WaterLevel() == 3 then
		self:EmitSound("weapons/shotgun/shotgun_empty.wav", 65, rand(99, 101))
		self:SetNextSecondaryFire( CT + 0.05 )
		self:SetNextPrimaryFire( CT + 0.25 )
		return
	end
	
	if DTInt3 == 2 then
		return
	end
	
	if ( !self:CanPrimaryAttack() ) then 
		return
	end
	
	self:TakePrimaryAmmo( 1 )
	self:SetNextSecondaryFire( CT + self.Primary.Delay )
	self:SetNextPrimaryFire( CT + self.Primary.Delay )
	RecMod = GetGlobalFloat("CR")
	
	if SERVER then
		if self.IsSilenced == false then
			self.Owner:EmitSound(self.Primary.Sound, 101, rand(99, 101))
		else
			if self.AltSilencedSound == true then
				self.Owner:EmitSound("weapons/scout/scout_fire-1.wav", 70, rand(99, 101))
			else
				self.Owner:EmitSound(((self:GetClass():find("^cstm_pistol_") or self:GetClass():find("^cstm_smg_")) and "weapons/usp/usp1.wav") or "weapons/m4a1/m4a1-1.wav", 70, rand(99, 101))
			end
		end
	end
	
	if self:GetDTInt(2) == 2 then
		if SERVER then
			ent = ents.Create("round_frag")
			AimVec = self.Owner:GetAimVector()
			EyeAng = self.Owner:EyeAngles()
			Offset = nil
			
			if DTInt3 != 1 then
				Offset = EyeAng:Up() * -5 + EyeAng:Right() * 6
			else
				Offset = EyeAng:Up() * -5
			end
			
			ent:SetPos(self.Owner:GetShootPos() + AimVec * 30 + Offset)
			ent:SetAngles(self.Owner:EyeAngles())
			ent:Spawn()
			ent:GetPhysicsObject():SetVelocity(AimVec * 2000)
			ent.Owner = self.Owner
		end
			
		self:SendWeaponAnim(ACT_VM_PRIMARYATTACK) 		// View model animation
		self.Owner:GetViewModel():SetPlaybackRate(self.PlaybackRate or 1) -- some weapons in the pack have slow recoil animation, so I've decided to slightly speed it up
			
		if self.IsSilenced == false then
			self.Owner:MuzzleFlash()								// Crappy muzzle light
		end
			
		self.Owner:SetAnimation(PLAYER_ATTACK1)				// 3rd Person Animation
		
		if DTInt3 == 1 then
			self:Recoil(self.Primary.Recoil * 0.75 * RecMod)
		else
			self:Recoil(self.Primary.Recoil * 1.2 * RecMod)
		end
		
		self.Owner:ViewPunch( Angle(-1 * (self.Primary.Recoil + self.ConeInaccuracy * 4) * (1 - (self.RecoilAff1 + self.RecoilAff2 + self.RecoilAff3)), 0, 0 ) * RecMod )
		
		return
	end
	
	self.ReloadDelay = CT + 0.5
	
	if DTInt3 != 1 then
		self:CSShootBullet( self.Primary.Damage, self.Primary.Recoil * 1.2, self.Primary.NumShots, self:GetDTFloat(0))
	else
		self:CSShootBullet( self.Primary.Damage, self.Primary.Recoil * 0.75, self.Primary.NumShots, self:GetDTFloat(0))
	end
	
	if self.Owner:Crouching() then
		ConeDecAff1 = 0.02
		self.RecoilAff2 = 0.3
	else
		ConeDecAff1 = 0
		self.RecoilAff2 = 0
	end
	
	if self:GetDTInt(3) == 1 then
		ConeDecAff2 = 0.01
		self.RecoilAff1 = 0.3
	else
		ConeDecAff2 = 0
		self.RecoilAff1 = 0
	end
	
	if DTInt3 == 1 then
		self:Recoil(self.Primary.Recoil * 0.75 * RecMod)
	else
		self:Recoil(self.Primary.Recoil * 1.2 * RecMod)
	end
	
	self.Owner:ViewPunch( Angle(-1 * (self.Primary.Recoil + self.ConeInaccuracy * 4) * (1 - (self.RecoilAff1 + self.RecoilAff2 + self.RecoilAff3)), 0, 0 ) * RecMod )
	
	if ( self.Owner:IsNPC() ) then return end
end

function SWEP:CSShootBullet( dmg, recoil, numbul, cone )
	numbul 	= numbul 	or 1
	cone 	= cone 		or 0.01
		
	/*local offset
	
	if self:GetDTInt(3) == 10 then
		offset = self.Owner:EyeAngles():Right() * 10
	elseif self:GetDTInt(3) == 11 then
		offset = self.Owner:EyeAngles():Right() * -10
	elseif self:GetDTInt(3) == 12 then
		offset = self.Owner:EyeAngles():Up() * 10
	else
		offset = Vector(0, 0, 0)
	end*/
		
	if self.dt.Sil then
		damagemod1 = 0.1
	else
		damagemod1 = 0
	end
	
	if self:GetDTInt(2) == 1 then
		damagemod2 = 0.3
	else
		damagemod2 = 0
	end
	
	if SinglePlayer() then
		if SERVER then
			for i = 1, self.Primary.NumShots do
				self.Owner:FireBulletsEx(1, self.Owner:GetShootPos(), (self.Owner:EyeAngles() + self.Owner:GetPunchAngle()):Forward(), self.Primary.Damage * (1 - (damagemod1 + damagemod2)), self:GetDTFloat(0), 10)
			end
		end
	else
		bullet = {}
		bullet.Num 		= numbul
		bullet.Src 		= self.Owner:GetShootPos()			// Source
		bullet.Dir 		= ( self.Owner:EyeAngles() + self.Owner:GetPunchAngle() ):Forward()		// Dir of bullet
		bullet.Spread 	= Vector( cone, cone, 0 )			// Aim Cone
		bullet.Tracer	= 4									// Show a tracer on every x bullets 
		bullet.Force	= self.Primary.Damage		// Amount of force to give to phys objects
		bullet.Damage = math.Round(self.Primary.Damage * (1 - (damagemod1 + damagemod2 )))
		
		bullet.Callback = function(attacker, trace, dmginfo)
			if SERVER and self:GetDTInt(2) == 1 then
				if ValidEntity(trace.Entity) then
					trace.Entity:Ignite(6)
				end
			end
			
			--[[local penetrationForce
			local hitMat = trace.MatType 
			
			if hitMat == MAT_PLASTIC then
				penetrationForce = 1.25
			elseif hitMat == MAT_WOOD then
				penetrationForce = 1
			elseif hitMat == MAT_TILE then
				penetrationForce = 0.75
			elseif hitMat == MAT_CONCRETE then
				penetrationForce = 0.5
			elseif hitMat == MAT_METAL or hitMat == MAT_VENT then
				penetrationForce = 0.5
			else
				penetrationForce = 1
			end
			
			local forward = bullet.Dir:Normalize()
			local tr = {}
			tr.start = trace.HitPos
			tr.endpos = tr.start
			tr.filter = self
			
			local trace2 = util.TraceLine(tr)
			
			if not trace2.HitWorld and trace.Entity != trace2.Entity then
				local bullet2 = {}
				bullet2.Num = bullet.Num
				bullet2.Src = trace.HitPos + forward * 8 * penetrationForce
				bullet2.Dir = bullet.Dir
				bullet2.Spread = Vector(0, 0, 0)
				bullet2.Tracer = bullet.Tracer
				bullet2.Force = bullet.Force * 0.5
				bullet2.Damage = bullet.Damage * 0.5
				//ParticleEffect("cstm_penetration_smoke", trace.HitPos + (forward * 4) * penetrationForce, Angle(0, 0, 0), nil)

				if SERVER then
					self.Owner:LagCompensation(false)
				end
				
				self.Owner:FireBullets(bullet2)
			end]]--
			
		end
		
		self.Owner:FireBullets(bullet)
	end
	
	self:SendWeaponAnim(ACT_VM_PRIMARYATTACK) 		// View model animation
	
	self.Owner:GetViewModel():SetPlaybackRate(self.PlaybackRate or 1) -- some weapons in the pack have slow recoil animation, so I've decided to slightly speed it up
	
	if self.IsSilenced == false then
		self.Owner:MuzzleFlash()								// Crappy muzzle light
	end
	
	self.Owner:SetAnimation(PLAYER_ATTACK1)				// 3rd Person Animation
	
	if ( self.Owner:IsNPC() ) then return end
	
	// CUSTOM RECOIL !
end