CreateClientConVar("cstm_different_origins", "0", true, true)
CreateClientConVar("cstm_leftcross", "1", true, true)
CreateClientConVar("cstm_rightcross", "1", true, true)
CreateClientConVar("cstm_lowercross", "1", true, true)
CreateClientConVar("cstm_uppercross", "1", true, true)
CreateClientConVar("cstm_out_r", "0", true, true)
CreateClientConVar("cstm_out_g", "0", true, true)
CreateClientConVar("cstm_out_b", "0", true, true)
CreateClientConVar("cstm_out_a", "255", true, true)
CreateClientConVar("cstm_in_r", "255", true, true)
CreateClientConVar("cstm_in_g", "255", true, true)
CreateClientConVar("cstm_in_b", "255", true, true)
CreateClientConVar("cstm_in_a", "255", true, true)
CreateClientConVar("cstm_crosslength", "11", true, true)
CreateClientConVar("cstm_dynamiccrosshair", "0", true, true)
CreateClientConVar("cstm_moresway", "0", true, true)
CreateClientConVar("cstm_ef_heat", "0", true, true)
CreateClientConVar("cstm_ef_smoke", "0", true, true)
CreateClientConVar("cstm_ef_blur", "0", true, true)
CreateClientConVar("cstm_ef_extramuzzle", "1", true, true)
CreateClientConVar("cstm_ef_sparks", "1", true, true)
CreateClientConVar("cstm_aim_sensitivity", "0.01", true, true)
CreateClientConVar("cstm_oldacog", "0", true, true)
CreateClientConVar("cstm_viewbob_reload", "1", true, true)
CreateClientConVar("cstm_viewbob_silencer", "1", true, true)
CreateClientConVar("cstm_viewbob_draw", "1", true, true)
CreateClientConVar("cstm_hold_to_aim", "1", true, true)
include("autorun/particleprecache.lua")

local CurAlpha = 0
local PitchMod = 0
local YawMod = 0
local RollMod = 0
local PAPR = 0 -- pitch approach rate
local YAPR = 0 -- yaw approach rate
local RAPR = 0 -- roll approach rate
local PT = 0 -- pitch target
local YT = 0 -- yaw target
local RT = 0 -- roll target
local PT2 = 0
local RT2 = 0

local ply, wep, vm, attachment, FT, CT, vel, runspeed, view, eyeang, activity, str, ShakeSTR, WeaponAnglePitch, WeaponAngleRoll, func, x, y
local rbox, app, cos, rand = draw.RoundedBox, math.Approach, math.cos, math.random

local function TWeps_HUDPaint()
	ply = LocalPlayer()

	if ply:Alive() and ValidEntity(ply:GetActiveWeapon()) then
		if not ValidEntity(ply.MedkitWeapon) then
			for k, v in pairs(ply:GetWeapons()) do
				if v:GetClass() == "test_medkit" then
					ply.MedkitWeapon = v
					break
				end
			end
		end
		
		if ValidEntity(ply.MedkitWeapon)  then
			if ply.MedkitWeapon.dt.progress == 100 then
				CurAlpha = app(CurAlpha, 0, 6)
			else
				CurAlpha = app(CurAlpha, 255, 6)
			end
		else
			return
		end
		
		x, y = ScrW(), ScrH()
		
		rbox(4, x * 0.5 - 100, y * 0.8, 200, 16, Color(0, 0, 0, CurAlpha))
		rbox(4, x * 0.5 - 99, y * 0.8 + 1, 198, 14, Color(70, 70, 70, CurAlpha))
		
		if ValidEntity(ply.MedkitWeapon) then
			if ply.MedkitWeapon.dt.progress > 1 then
				rbox(4, x * 0.5 - 99, y * 0.8 + 1, ply.MedkitWeapon.dt.progress * 1.98, 14, Color(174, 255, 0, CurAlpha))
			end
		end
	end
end

hook.Add("HUDPaint", "TWeps_HUDPaint", TWeps_HUDPaint)

local time = 0
local WeaponAngle = 0
local animplayed = true
local lastanim = ""
local lastwep = ""
local att, x, y

local vcret = vgui.Create

local function TWeps_Think()
	ply = LocalPlayer()
	vm = ply:GetViewModel()
	
	if ValidEntity(vm) then
		attachment = vm:GetAttachment("1")
	end
	
	if attachment then
		ply.attachment = attachment -- getting the attachment in a Think hook, because CalcView doesn't seem to like GetAttachment and pretty much breaks
	end
	
	for k, v in pairs(player.GetAll()) do
		wep = v:GetActiveWeapon()
		
		if ValidEntity(wep) then
			if wep.ReposMyBones and wep.BonesToRepos then
				v.BuildBonePositions = wep.BoneReposFunc
			end
		end
	end
	
	wep = ply:GetActiveWeapon()
	
	if ValidEntity(wep) then
		if wep.IsCustomWeapon then
			if wep:GetDTInt(3) == 19 then
				if wep.Attachments then
					if #PAs == 0 then
						if not AttOnMe then
							AttOnMe = {}
						end
						
						for k, v in ipairs(wep.Attachments) do
							x, y = ScrW(), ScrH()
							
							if ValidEntity(vm) then
								att = vm:GetAttachment("1")
								
								if att then
									att = att.Pos:ToScreen()
								end
							end
							
							PA = vcret("AttachmentSelectionPanel")
							PA:SetSize(160, 75)
							PA.Off = 80 * (k - 1) - 40 * #wep.Attachments
							PA.Key = k
							
							if not att or att.x > x or att.y > y or att.x < 0 or att.y < 0 then
								PA:SetPos(200, y * 0.5 + PA.Off)
								PA.DontRepos = true
							else
								PA:SetPos(att.x + 200, att.y + PA.Off - 50)
							end
									
							table.insert(PAs, PA)
							
							for k2, v2 in ipairs(v) do
								PA2 = vcret("AttachmentIcon", PA)
								PA2:SetSize(50, 50)
								PA2:SetPos(52 * (k2 - 1) + 2, 20)
								PA2.Att = v2
								PA2.Texture = AttToMdl[v2].t
							end
						end
					else
						for k, v in pairs(PAs) do
							if not ValidPanel(v) then
								v:Remove()
							end
						end
					end
				end
			else
				if PAs then
					if #PAs > 0 then
						for k, v in pairs(PAs) do
							if ValidPanel(v) then
								v:Remove()
							end
						end
						
						PAs = {}
						return
					end
				else
					PAs = {}
				end
			end
		end
	end
end

hook.Add("Think", "TWeps_Think", TWeps_Think)

local CurWeaponAngleMod = 1
local WeaponAngle = 0
local ShakeSTR = Angle(0, 0, 0)
local CurShake = Angle(0, 0, 0)

local function TWeps_ViewShake(ply, pos, angles, fov)
	FT = FrameTime()
	CT = CurTime()
	wep = ply:GetActiveWeapon()
	vel = ply:GetVelocity():Length()
	runspeed = ply:GetRunSpeed()
	
	if not wep.IsCustomWeapon then
		animplayed = false
		return //GAMEMODE:CalcView( ply, pos, angles, fov )
	end

	view = {}
	
	if ValidEntity(wep) and wep:GetClass():find("^cstm_") then
		if ply:OnGround() then 
			if ply:KeyDown(IN_SPEED) and vel > ply:GetWalkSpeed() * 1.2 then
				PAPR = 0.5
				YAPR = 0.5
				RAPR = 0.5
				PT = cos(CT * (runspeed / 18)) * 0.35
				YT = cos(CT * 10) * 0.1
				RT = cos(CT * 10) * 0.2
				
			elseif vel < ply:GetRunSpeed() and vel > 50 and not ply:KeyDown(IN_SPEED) then
				PAPR = 0.6
				YAPR = 0.6
				RAPR = 0.6
				PT = cos(CT * 15) * 0.1
				YT = cos(CT * 10) * 0.05
				RT = cos(CT * 10) * 0.05
			elseif ValidEntity(wep) and wep:GetDTInt(3) == 1 and vel < runspeed and vel > 50 and not ply:KeyDown(IN_SPEED) then
				PAPR = 0.6
				YAPR = 0.6
				RAPR = 0.6
				PT = cos(CT * 15) * 0.1
				YT = cos(CT * 10) * 0.05
				RT = cos(CT * 10) * 0.05
			else
				PAPR = 0.25
				YAPR = 0.25
				RAPR = 0.25
				PT = 0
				YT = 0
				RT = 0
			end
					
			if ply:KeyDown(IN_SPEED) and vel > ply:GetWalkSpeed() * 1.2 then
				if ply:KeyDown(IN_MOVELEFT) then
					RT2 = app(RT2, -1.5, 0.15)
				elseif ply:KeyDown(IN_MOVERIGHT) then
					RT2 = app(RT2, 1.5, 0.15)
				else
					RT2 = app(RT2, 0, 0.15)
				end
			else
				RT2 = app(RT2, 0, 0.15)
			end
					
		else
			PAPR = 0.05
			YAPR = 0.05
			PAPR = 0.05
			PT = 0
			YT = 0
			RT = 0
			PT2 = app(PT2, 0, 0.2)
			RT2 = app(RT2, 0, 0.2)
			
			if ply:GetVelocity().z <= -500 and ply:GetMoveType() == MOVETYPE_WALK then
				str = vel / 500
				ShakeSTR = Angle(rand(-str, str), rand(-str, str), rand(-str, str))
				
				CurShake = LerpAngle(0.1, CurShake, ShakeSTR)
			else
				ShakeSTR = Angle(0, 0, 0)
				CurShake = LerpAngle(0.2, CurShake, ShakeSTR)
			end
		end
	else
		PAPR = 0.05
		YAPR = 0.05
		PAPR = 0.05
		PT = 0
		YT = 0
		RT = 0
		PT2 = app(PT2, 0, 0.17)
		RT2 = app(RT2, 0, 0.17)
	end
	
	if ValidEntity(wep) then
		if wep:GetClass():find("^cstm_") then
			vm = ply:GetViewModel()
			eyeang = ply:EyeAngles()
			activity = wep:GetSequenceActivityName(wep:GetSequence())
				
			if ply.attachment then
				if GetConVarNumber("cstm_viewbob_reload") > 0 and (activity == "ACT_VM_RELOAD" or activity == "ACT_VM_RELOAD_SILENCED") or GetConVarNumber("cstm_viewbob_silencer") > 0 and (activity == "ACT_VM_ATTACH_SILENCER" or activity == "ACT_VM_DETACH_SILENCER") or GetConVarNumber("cstm_viewbob_draw") > 0 and (activity == "ACT_VM_DRAW" or activity == "ACT_VM_DRAW_SILENCED") then
					if lastanim != activity or lastwep != wep then
						animplayed = false
					end
					
					lastanim = activity
					lastwep = wep
					
					if CT > time and animplayed == false then
						time = CT + vm:SequenceDuration() - 0.3
						animplayed = true
					end
					
					if activity == "ACT_VM_RELOAD" or activity == "ACT_VM_RELOAD_SILENCED" then
						CurWeaponAngleMod = wep.ReloadAngleMod or 1
					elseif activity == "ACT_VM_DRAW" or activity == "ACT_VM_DRAW_SILENCED" then
						CurWeaponAngleMod = wep.DrawAngleMod or 1
					elseif activity == "ACT_VM_ATTACH_SILENCER" or activity == "ACT_VM_DETACH_SILENCER" then
						CurWeaponAngleMod = wep.SilencerAngleMod or 1
					end
				else
					animplayed = false
					time = 0
				end
			end
				
			if CT < time then
				WeaponAngle = app(WeaponAngle, ply.attachment.Ang.p * 0.15, FT * 70)
			else
				WeaponAngle = Lerp(FT * 10, WeaponAngle, 0)
			end
		else
			WeaponAngle = Lerp(FT * 10, WeaponAngle, 0)
			time = 0
			animplayed = false
			lastwep = ""
		end
	else
		WeaponAngle = Lerp(FT * 10, WeaponAngle, 0)
		time = 0
		animplayed = false
		lastwep = ""
	end
	
	PitchMod = app(PitchMod, PT, PAPR)
	YawMod = app(YawMod, YT, YAPR)
	RollMod = app(RollMod, RT, RAPR)
	
	WeaponAnglePitch = (WeaponAngle * (wep.PitchMod or 1) * CurWeaponAngleMod)
	WeaponAngleRoll = (WeaponAngle * (wep.RollMod or 1) * CurWeaponAngleMod)
	
	view.angles = angles + Angle(PitchMod + WeaponAnglePitch, YawMod, RollMod + RT2 + WeaponAngleRoll)
	
	view.origin = pos
	view.fov = fov
	
	wep = ply:GetActiveWeapon()
	
	if (ValidEntity(wep)) then
	
		func = wep.GetViewModelPosition
		
		if ( func ) then
			view.vm_origin,  view.vm_angles = func( wep, pos * 1, angles * 1 ) // Note: *1 to copy the object so the child function can't edit it.
		end
		
		func = wep.CalcView
		
		if ( func ) then
			view.origin, view.angles, view.fov = func( wep, ply, pos * 1, angles * 1, fov ) // Note: *1 to copy the object so the child function can't edit it.
		end
	
	end
	
	return GAMEMODE:CalcView(ply, view.origin, view.angles, view.fov)
end

hook.Add("CalcView", "TWeps_ViewShake", TWeps_ViewShake)

local Blur = 0

local function TWeps_SightsBlur( x, y, fwd, spin )
	Blur = app(Blur, 0, 0.01)
	ply = LocalPlayer()
	wep = ply:GetActiveWeapon()
	
	if wep == NULL then
		return x, y, fwd, spin
	end
	
	if GetConVarNumber("cstm_ef_blur") > 0 then
		if GetConVarNumber("mat_motion_blur_forward_enabled") < 1 then
			RunConsoleCommand("mat_motion_blur_forward_enabled", "1")
		end
	
		if wep:GetClass():find("^cstm_rif_") or wep:GetClass():find("^cstm_smg_") or wep:GetClass():find("^cstm_shotgun_") or wep:GetClass():find("^cstm_pistol_") then
			if wep:IsValid() then
				if wep:GetDTInt(3) == 1 or wep:GetDTInt(3) == 2 then
					Blur = app(Blur, 0.015, 0.01)
				end
			end
		end
	else
		if GetConVarNumber("mat_motion_blur_forward_enabled") != 0 then
			RunConsoleCommand("mat_motion_blur_forward_enabled", "0")
		end
	end
	
	return x, y, Blur, spin
end

hook.Add("GetMotionBlurValues", "TWeps_SightsBlur", TWeps_SightsBlur)

local s

local AttToText = {
	["acog"] = "ACOG 4x Scope",
	["aimpoint"] = "Aimpoint holo-scope",
	["eotech"] = "EoTech 557 holo-sight",
	["reflex"] = "Docter reflex sight",
	["vertgrip"] = "Foregrip",
	["cmag"] = "Beta C-Magazine",
	["grenadelauncher"] = "M203",
	["laser"] = "Laser Sight",
	["bipod"] = "Bipod"}
	
local function GetAttachments(um)
	s = um:ReadString()
	
	if not AttOnMe then
		AttOnMe = {}
	end
	
	s = string.Explode(" ", s)
	
	for k, v in pairs(s) do
		table.insert(AttOnMe, v)
	end
end

usermessage.Hook("GETATTS", GetAttachments)

local function PickUpAttachment(um)
	s = um:ReadString()
	
	if not AttOnMe then
		AttOnMe = {}
	end
	
	table.insert(AttOnMe, s)
	chat.AddText(Color(255, 255, 255), "Got new weapon attachment: ", Color(50, 150, 255), AttToText[s], Color(255, 255, 255), ".")
end

usermessage.Hook("PICKUPATT", PickUpAttachment)

local function PickUpAttachmentSilent(um)
	s = um:ReadString()
	
	if not AttOnMe then
		AttOnMe = {}
	end
	
	table.insert(AttOnMe, s)
end

usermessage.Hook("PICKUPATTSIL", PickUpAttachmentSilent)

local function RemoveAttachments()
	AttOnMe = {}
end

usermessage.Hook("REMATT", RemoveAttachments)