AddCSLuaFile("cl_init.lua")
AddCSLuaFile("shared.lua")
include("shared.lua")

function ENT:Initialize()
	self.Entity:SetModel("models/weapons/W_missile_closed.mdl") 
	self.Entity:PhysicsInit(SOLID_VPHYSICS)
	self.Entity:SetMoveType(MOVETYPE_VPHYSICS)
	self.Entity:SetSolid(SOLID_VPHYSICS)
	self.Entity:SetCollisionGroup(COLLISION_GROUP_NPC)
	local phys = self.Entity:GetPhysicsObject()

	if phys and phys:IsValid() then
		phys:Wake()
	end
end

function ENT:OnTakeDamage(dmginfo)
	return false
end

function ENT:Use(activator, caller)
	return false
end

function ENT:PhysicsCollide(data, physobj)
	self.Entity:Explode()
	self.Entity.BlewUp = true
end

function ENT:Explode()
	if self.Entity.BlewUp then
		return
	end
	
	local owner = self.Entity.Owner
	
	/*local ED = EffectData()
	ED:SetOrigin(self.Entity:GetPos())
	
	util.Effect("Explosion", ED)*/
	
	WorldSound("weapons/explode" .. math.random(3, 5) .. ".wav", self:GetPos(), 98, 100)
	ParticleEffect("cstm_frag_expl", self.Entity:GetPos(), Angle(0, 0, 0), nil)
	
	for k, v in pairs(ents.FindInSphere(self.Entity:GetPos(), 128)) do
		if ValidEntity(v) then
			if not v:IsPlayer() or not v:IsNPC() and (v:GetClass() == "prop_physics" or v:GetClass() == "prop_ragdoll") then
			
				local phys = v:GetPhysicsObject()
				
				if not v.ReceivedExplosiveForce then
					v.ReceivedExplosiveForce = 300
				else
					v.ReceivedExplosiveForce = v.ReceivedExplosiveForce + 300
				end
				
				if ValidEntity(phys) then
					local distance = self.Entity:GetPos():Distance(v:GetPos())
					local relation = math.Clamp(((128 - distance) / 128) / (phys:GetMass() * 0.005), 0, 1)
					local forceDir = ((v:GetPos() - self.Entity:GetPos()):GetNormal() * 500) * relation
					
					if phys:IsMoveable() then
						phys:AddAngleVelocity(Vector(500, 500, 100) * relation)
						phys:SetVelocity(forceDir)
					end
					
					if v.ReceivedExplosiveForce >= phys:GetMass() then
						constraint.RemoveAll(v)
						
						phys:Wake()
						phys:EnableMotion(true)
						
						phys:AddAngleVelocity(Vector(500, 500, 100) * relation)
						phys:SetVelocity(forceDir)
						
						v.ReceivedExplosiveForce = 0
					end
				end
				
			end
		end
	end
	
	util.BlastDamage(self.Entity, owner, self.Entity:GetPos(), 128, 50)
	
	SafeRemoveEntity(self.Entity)
end